// Emacs -*- C++ -*-

// Machine generated include file, do not modify.


// 	Copyright 1993, Center for Computer Vision and Visualization,
// 	University of Florida.  All rights reserved.


//  $Log: bit-operations.desc,v $
//  Revision 1.6.1.2  1995/01/31  16:02:40  thoth
//  Need to replace the upward conversions with something...

//  Revision 1.6.1.1  1994/12/28  17:49:18  thoth
//  Image operations are now friendly with FBI.
//  Image ops now use operations table instead of switch.

//  Revision 1.6  1994/08/22  15:20:29  thoth
//  DOS-inspired name rework.

//  Revision 1.5  1994/05/17  12:54:56  thoth
//  Improved operations generation scheme.  Lines from the op.desc file can
//  be quoted into the .c file to allow inclusion of infrastructure.  Also
//  the op.desc output can be redirected to several files.  The prefix
//  directive allows common information (include files) to be included in
//  every generated source file.

//  Revision 1.4  1994/02/03  16:22:48  thoth
//  Arguments to binary operations were specified "lhs rhs return" but are
//  now specified "return lhs rhs" to be consistent with function declaration
//  syntax.

//  Revision 1.3  1994/01/31  15:51:12  thoth
//  converters to CoreImages now available.

//  Revision 1.2  1993/12/29  17:16:45  thoth
//  Bit Discrete Image now uses Bit type.

//  Revision 1.1  1993/11/29  22:25:25  thoth
//  Initial revision


#include "BitDI.h"
#include "VectorI.h"
#include "ConstI.h"
#include "ImageIter.h"
#include "FBI.h"
#include "../valueset/OpTable.h"
//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// binary pointwise commutative operator| I(IA_Bit) I(IA_Bit) I(IA_Bit)
//
#ifndef BOT_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
#define BOT_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, IA_Bit>*,
	IA_BaseImage<IA_Point<int>, IA_Bit>,
	IA_BaseImage<IA_Point<int>, IA_Bit> >
	*IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl;

void IA_fill_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl();

#endif // BOT_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
IA_Image<IA_Point<int>, IA_Bit>
operator| ( const IA_Image<IA_Point<int>, IA_Bit> &lhs,
		const IA_Image<IA_Point<int>, IA_Bit> &rhs)
{
    if (lhs.domain() != rhs.domain()) {
	 IA_Image<IA_Point<int>, IA_Bit>	rval;
	ia_throw(Image_DomainMismatch_Exception(__FILE__,__LINE__));
	return rval;
    }

    if (!IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl)
	IA_fill_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl();

    IA_BaseImage<IA_Point<int>, IA_Bit>*(*f)( IA_BaseImage<IA_Point<int>, IA_Bit> &,
		IA_BaseImage<IA_Point<int>, IA_Bit> &);
    f = IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl->lookup_operation
	(lhs.type(), rhs.type());
    IA_BaseImage<IA_Point<int>,IA_Bit>	&basel = *IA_FBI<IA_Point<int>,IA_Point<int>, IA_Bit,IA_Bit,IA_Bit>
	    ::extract_baseptr(lhs);
    IA_BaseImage<IA_Point<int>,IA_Bit>	&baser = *IA_FBI<IA_Point<int>,IA_Point<int>, IA_Bit,IA_Bit,IA_Bit>
	    ::extract_baseptr(rhs);
    return IA_Image<IA_Point<int>,IA_Bit>
	(IA_FBI<IA_Point<int>,IA_Point<int>, IA_Bit,IA_Bit,IA_Bit>
	 ::make_Image(	 f(basel,baser)));
}

//
//
//

static IA_BaseImage<IA_Point<int>, IA_Bit> *
vec_vec_bo_operatorIAOPbo(IA_BaseImage<IA_Point<int>, IA_Bit> &lhs_,
	IA_BaseImage<IA_Point<int>, IA_Bit> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    IA_Bit *const vec = new IA_Bit[sz];

    {
	IA_Bit *ds = vec;
	IA_VectorI<IA_Point<int>, IA_Bit> *lhs
		= (IA_VectorI<IA_Point<int>, IA_Bit> *)&lhs_;
	const IA_Bit *ls = lhs->vec;
	IA_VectorI<IA_Point<int>, IA_Bit> *rhs
		= (IA_VectorI<IA_Point<int>, IA_Bit> *)&rhs_;
	const IA_Bit *rs = rhs->vec;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = ( (*ls) | (*rs) );
	    ls++;
	    rs++;
	}
    }
    return new IA_VectorI<IA_Point<int>, IA_Bit>(domain, vec, sz, 1);
}

#ifndef vec_scalar_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
#define vec_scalar_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
static IA_BaseImage<IA_Point<int>, IA_Bit> *
vec_scalar_bo_operatorIAOPbo(IA_BaseImage<IA_Point<int>, IA_Bit> &lhs_,
	IA_BaseImage<IA_Point<int>, IA_Bit> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    IA_Bit *const vec = new IA_Bit[sz];

    {
	IA_Bit *ds = vec;
	IA_VectorI<IA_Point<int>, IA_Bit> *lhs
		= (IA_VectorI<IA_Point<int>, IA_Bit> *)&lhs_;
	const IA_Bit *ls = lhs->vec;
	IA_ConstI<IA_Point<int>, IA_Bit> *rhs
		= (IA_ConstI<IA_Point<int>, IA_Bit> *)&rhs_;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = ( (*ls) | (rhs->value) );
	    ls++;
	}
    }
    return new IA_VectorI<IA_Point<int>, IA_Bit>(domain, vec, sz, 1);
}
#endif // vec_scalar_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo

static IA_BaseImage<IA_Point<int>, IA_Bit> *
vec_iter_bo_operatorIAOPbo(IA_BaseImage<IA_Point<int>, IA_Bit> &lhs_,
	IA_BaseImage<IA_Point<int>, IA_Bit> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    IA_Bit *const vec = new IA_Bit[sz];

    {
	IA_Bit *ds = vec;
	IA_VectorI<IA_Point<int>, IA_Bit> *lhs
		= (IA_VectorI<IA_Point<int>, IA_Bit> *)&lhs_;
	const IA_Bit *ls = lhs->vec;
	IA_Bit rtmp;
	IA_BaseIVIter<IA_Point<int>, IA_Bit>	*riter = rhs_.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    riter->next(rtmp);
	    *(ds++) = ( (*ls) | (rtmp) );
	    ls++;
	}
	delete riter;
    }
    return new IA_VectorI<IA_Point<int>, IA_Bit>(domain, vec, sz, 1);
}

#ifndef scalar_vec_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
#define scalar_vec_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
static IA_BaseImage<IA_Point<int>, IA_Bit> *
scalar_vec_bo_operatorIAOPbo(IA_BaseImage<IA_Point<int>, IA_Bit> &lhs_,
	IA_BaseImage<IA_Point<int>, IA_Bit> &rhs_)
{
    return vec_scalar_bo_operatorIAOPbo(rhs_, lhs_);
}
#endif // scalar_vec_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo

#ifndef scalar_scalar_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
#define scalar_scalar_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
static IA_BaseImage<IA_Point<int>, IA_Bit> *
scalar_scalar_bo_operatorIAOPbo(IA_BaseImage<IA_Point<int>, IA_Bit> &lhs_,
	IA_BaseImage<IA_Point<int>, IA_Bit> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
	IA_ConstI<IA_Point<int>, IA_Bit> *lhs
		= (IA_ConstI<IA_Point<int>, IA_Bit> *)&lhs_;
	IA_ConstI<IA_Point<int>, IA_Bit> *rhs
		= (IA_ConstI<IA_Point<int>, IA_Bit> *)&rhs_;
    IA_Bit	aval = ( lhs->value | rhs->value );
    return new IA_ConstI<IA_Point<int>, IA_Bit>(domain, aval);
}
#endif // scalar_scalar_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo

#ifndef scalar_iter_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
#define scalar_iter_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
static IA_BaseImage<IA_Point<int>, IA_Bit> *
scalar_iter_bo_operatorIAOPbo(IA_BaseImage<IA_Point<int>, IA_Bit> &lhs_,
	IA_BaseImage<IA_Point<int>, IA_Bit> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    IA_Bit *const vec = new IA_Bit[sz];

    {
	IA_Bit *ds = vec;
	IA_ConstI<IA_Point<int>, IA_Bit> *lhs
		= (IA_ConstI<IA_Point<int>, IA_Bit> *)&lhs_;
	IA_Bit rtmp;
	IA_BaseIVIter<IA_Point<int>, IA_Bit>	*riter = rhs_.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    riter->next(rtmp);
	    *(ds++) = ( (lhs->value) | (rtmp) );
	}
	delete riter;
    }
    return new IA_VectorI<IA_Point<int>, IA_Bit>(domain, vec, sz, 1);
}
#endif // scalar_iter_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo

static IA_BaseImage<IA_Point<int>, IA_Bit> *
iter_vec_bo_operatorIAOPbo(IA_BaseImage<IA_Point<int>, IA_Bit> &lhs_,
	IA_BaseImage<IA_Point<int>, IA_Bit> &rhs_)
{
    return vec_iter_bo_operatorIAOPbo(rhs_, lhs_);
}

#ifndef iter_scalar_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
#define iter_scalar_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
static IA_BaseImage<IA_Point<int>, IA_Bit> *
iter_scalar_bo_operatorIAOPbo(IA_BaseImage<IA_Point<int>, IA_Bit> &lhs_,
	IA_BaseImage<IA_Point<int>, IA_Bit> &rhs_)
{
    return scalar_iter_bo_operatorIAOPbo(rhs_, lhs_);
}
#endif // iter_scalar_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo

static IA_BaseImage<IA_Point<int>, IA_Bit> *
iter_iter_bo_operatorIAOPbo(IA_BaseImage<IA_Point<int>, IA_Bit> &lhs_,
	IA_BaseImage<IA_Point<int>, IA_Bit> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    IA_Bit *const vec = new IA_Bit[sz];

    {
	IA_Bit *ds = vec;
	IA_Bit ltmp;
	IA_BaseIVIter<IA_Point<int>, IA_Bit>	*liter = lhs_.value_iterator();
	IA_Bit rtmp;
	IA_BaseIVIter<IA_Point<int>, IA_Bit>	*riter = rhs_.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    liter->next(ltmp);
	    riter->next(rtmp);
	    *(ds++) = ( (ltmp) | (rtmp) );
	}
	delete liter;
	delete riter;
    }
    return new IA_VectorI<IA_Point<int>, IA_Bit>(domain, vec, sz, 1);
}

#ifndef FILL_BOT_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
#define FILL_BOT_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
void IA_fill_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl()
{
    if (IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl)
	return;

    IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, IA_Bit>*,
	IA_BaseImage<IA_Point<int>, IA_Bit>,
	IA_BaseImage<IA_Point<int>, IA_Bit> >::function f;
    f = iter_iter_bo_operatorIAOPbo;

    IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl = new IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, IA_Bit>*,
	IA_BaseImage<IA_Point<int>, IA_Bit>,
	IA_BaseImage<IA_Point<int>, IA_Bit> >(iter_iter_bo_operatorIAOPbo);
    IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl->add_operation
	(IA_VectorI<IA_Point<int>, IA_Bit>::s_type(),
	 IA_VectorI<IA_Point<int>, IA_Bit>::s_type(),
	 vec_vec_bo_operatorIAOPbo);
    IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl->add_operation
	(IA_VectorI<IA_Point<int>, IA_Bit>::s_type(),
	 IA_ConstI<IA_Point<int>, IA_Bit>::s_type(),
	 vec_scalar_bo_operatorIAOPbo);
    IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl->add_operation
	(IA_VectorI<IA_Point<int>, IA_Bit>::s_type(),
	 0,
	 vec_iter_bo_operatorIAOPbo);

    IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl->add_operation
	(IA_ConstI<IA_Point<int>, IA_Bit>::s_type(),
	 IA_VectorI<IA_Point<int>, IA_Bit>::s_type(),
	 scalar_vec_bo_operatorIAOPbo);
    IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl->add_operation
	(IA_ConstI<IA_Point<int>, IA_Bit>::s_type(),
	 IA_ConstI<IA_Point<int>, IA_Bit>::s_type(),
	 scalar_scalar_bo_operatorIAOPbo);
    IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl->add_operation
	(IA_ConstI<IA_Point<int>, IA_Bit>::s_type(),
	 0,
	 scalar_iter_bo_operatorIAOPbo);

    IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl->add_operation
	(0,
	 IA_VectorI<IA_Point<int>, IA_Bit>::s_type(),
	 iter_vec_bo_operatorIAOPbo);
    IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl->add_operation
	(0,
	 IA_ConstI<IA_Point<int>, IA_Bit>::s_type(),
	 iter_scalar_bo_operatorIAOPbo);

}
#endif // BOT_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo

//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// binary pointwise commutative operator| I(IA_Bit) I(IA_Bit) IA_Bit
//
#ifndef BOT_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
#define BOT_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, IA_Bit>*,
	IA_BaseImage<IA_Point<int>, IA_Bit>,
	IA_BaseImage<IA_Point<int>, IA_Bit> >
	*IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl;

void IA_fill_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl();

#endif // BOT_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
IA_Image<IA_Point<int>, IA_Bit>
operator| ( const IA_Image<IA_Point<int>, IA_Bit> &lhs,
		IA_Bit rhs)
{
    if (!IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl)
	IA_fill_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl();

    IA_BaseImage<IA_Point<int>, IA_Bit>*(*f)( IA_BaseImage<IA_Point<int>, IA_Bit> &,
		IA_BaseImage<IA_Point<int>, IA_Bit> &);
    f = IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl->lookup_operation
	(lhs.type(), IA_ConstI<IA_Point<int>, IA_Bit>::s_type());
    IA_BaseImage<IA_Point<int>,IA_Bit>	&basel = *IA_FBI<IA_Point<int>,IA_Point<int>, IA_Bit,IA_Bit,IA_Bit>
	    ::extract_baseptr(lhs);
    IA_ConstI<IA_Point<int>,IA_Bit>	baser(lhs.domain(), rhs);
    return IA_Image<IA_Point<int>,IA_Bit>
	(IA_FBI<IA_Point<int>,IA_Point<int>, IA_Bit,IA_Bit,IA_Bit>
	 ::make_Image(	 f(basel,baser)));
}

//
//
//

#ifndef vec_scalar_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
#define vec_scalar_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
static IA_BaseImage<IA_Point<int>, IA_Bit> *
vec_scalar_bo_operatorIAOPbo(IA_BaseImage<IA_Point<int>, IA_Bit> &lhs_,
	IA_BaseImage<IA_Point<int>, IA_Bit> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    IA_Bit *const vec = new IA_Bit[sz];

    {
	IA_Bit *ds = vec;
	IA_VectorI<IA_Point<int>, IA_Bit> *lhs
		= (IA_VectorI<IA_Point<int>, IA_Bit> *)&lhs_;
	const IA_Bit *ls = lhs->vec;
	IA_ConstI<IA_Point<int>, IA_Bit> *rhs
		= (IA_ConstI<IA_Point<int>, IA_Bit> *)&rhs_;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = ( (*ls) | (rhs->value) );
	    ls++;
	}
    }
    return new IA_VectorI<IA_Point<int>, IA_Bit>(domain, vec, sz, 1);
}
#endif // vec_scalar_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo

#ifndef scalar_scalar_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
#define scalar_scalar_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
static IA_BaseImage<IA_Point<int>, IA_Bit> *
scalar_scalar_bo_operatorIAOPbo(IA_BaseImage<IA_Point<int>, IA_Bit> &lhs_,
	IA_BaseImage<IA_Point<int>, IA_Bit> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
	IA_ConstI<IA_Point<int>, IA_Bit> *lhs
		= (IA_ConstI<IA_Point<int>, IA_Bit> *)&lhs_;
	IA_ConstI<IA_Point<int>, IA_Bit> *rhs
		= (IA_ConstI<IA_Point<int>, IA_Bit> *)&rhs_;
    IA_Bit	aval = ( lhs->value | rhs->value );
    return new IA_ConstI<IA_Point<int>, IA_Bit>(domain, aval);
}
#endif // scalar_scalar_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo

#ifndef scalar_iter_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
#define scalar_iter_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
static IA_BaseImage<IA_Point<int>, IA_Bit> *
scalar_iter_bo_operatorIAOPbo(IA_BaseImage<IA_Point<int>, IA_Bit> &lhs_,
	IA_BaseImage<IA_Point<int>, IA_Bit> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    IA_Bit *const vec = new IA_Bit[sz];

    {
	IA_Bit *ds = vec;
	IA_ConstI<IA_Point<int>, IA_Bit> *lhs
		= (IA_ConstI<IA_Point<int>, IA_Bit> *)&lhs_;
	IA_Bit rtmp;
	IA_BaseIVIter<IA_Point<int>, IA_Bit>	*riter = rhs_.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    riter->next(rtmp);
	    *(ds++) = ( (lhs->value) | (rtmp) );
	}
	delete riter;
    }
    return new IA_VectorI<IA_Point<int>, IA_Bit>(domain, vec, sz, 1);
}
#endif // scalar_iter_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo

#ifndef iter_scalar_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
#define iter_scalar_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
static IA_BaseImage<IA_Point<int>, IA_Bit> *
iter_scalar_bo_operatorIAOPbo(IA_BaseImage<IA_Point<int>, IA_Bit> &lhs_,
	IA_BaseImage<IA_Point<int>, IA_Bit> &rhs_)
{
    return scalar_iter_bo_operatorIAOPbo(rhs_, lhs_);
}
#endif // iter_scalar_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo

#ifndef FILL_BOT_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
#define FILL_BOT_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo
void IA_fill_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl()
{
    if (IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl)
	return;

    IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, IA_Bit>*,
	IA_BaseImage<IA_Point<int>, IA_Bit>,
	IA_BaseImage<IA_Point<int>, IA_Bit> >::function f;
    f = iter_iter_bo_operatorIAOPbo;

    IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl = new IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, IA_Bit>*,
	IA_BaseImage<IA_Point<int>, IA_Bit>,
	IA_BaseImage<IA_Point<int>, IA_Bit> >(iter_iter_bo_operatorIAOPbo);
    IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl->add_operation
	(IA_VectorI<IA_Point<int>, IA_Bit>::s_type(),
	 IA_VectorI<IA_Point<int>, IA_Bit>::s_type(),
	 vec_vec_bo_operatorIAOPbo);
    IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl->add_operation
	(IA_VectorI<IA_Point<int>, IA_Bit>::s_type(),
	 IA_ConstI<IA_Point<int>, IA_Bit>::s_type(),
	 vec_scalar_bo_operatorIAOPbo);
    IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl->add_operation
	(IA_VectorI<IA_Point<int>, IA_Bit>::s_type(),
	 0,
	 vec_iter_bo_operatorIAOPbo);

    IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl->add_operation
	(IA_ConstI<IA_Point<int>, IA_Bit>::s_type(),
	 IA_VectorI<IA_Point<int>, IA_Bit>::s_type(),
	 scalar_vec_bo_operatorIAOPbo);
    IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl->add_operation
	(IA_ConstI<IA_Point<int>, IA_Bit>::s_type(),
	 IA_ConstI<IA_Point<int>, IA_Bit>::s_type(),
	 scalar_scalar_bo_operatorIAOPbo);
    IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl->add_operation
	(IA_ConstI<IA_Point<int>, IA_Bit>::s_type(),
	 0,
	 scalar_iter_bo_operatorIAOPbo);

    IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl->add_operation
	(0,
	 IA_VectorI<IA_Point<int>, IA_Bit>::s_type(),
	 iter_vec_bo_operatorIAOPbo);
    IA_Image_IP_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo_tbl->add_operation
	(0,
	 IA_ConstI<IA_Point<int>, IA_Bit>::s_type(),
	 iter_scalar_bo_operatorIAOPbo);

}
#endif // BOT_IA_Bit_IA_Bit_IA_Bit_operatorIAOPbo

//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// pointwise operator|= I(IA_Bit) I(IA_Bit)
//
// There are none (it's inline)

//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// pointwise operator|= I(IA_Bit) IA_Bit
//
// There are none (it's inline)

//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// filename BIO-__er.c
//
