// Emacs -*- C++ -*-

// Machine generated include file, do not modify.


// 	Copyright 1993, Center for Computer Vision and Visualization,
// 	University of Florida.  All rights reserved.


//  $Log: cplx-operations.desc,v $
//  Revision 1.8.1.2  1995/01/31  16:02:40  thoth
//  Need to replace the upward conversions with something...

//  Revision 1.8.1.1  1994/12/28  18:06:11  thoth
//  image operations are now friendly with FBI.
//  image ops now use operations table instead of switch.

//  Revision 1.8  1994/12/19  19:58:48  ljr
//  DOS-inspired name rework.

//  Revision 1.7  1994/08/22  15:20:29  thoth
//  DOS-inspired name rework.

//  Revision 1.6  1994/05/27  15:33:15  thoth
//  Pass-through C code wasn't passing through.

//  Revision 1.5  1994/05/17  12:54:56  thoth
//  Improved operations generation scheme.  Lines from the op.desc file can
//  be quoted into the .c file to allow inclusion of infrastructure.  Also
//  the op.desc output can be redirected to several files.  The prefix
//  directive allows common information (include files) to be included in
//  every generated source file.

//  Revision 1.4  1994/02/03  16:22:48  thoth
//  Arguments to binary operations were specified "lhs rhs return" but are
//  now specified "return lhs rhs" to be consistent with function declaration
//  syntax.

//  Revision 1.3  1994/01/31  15:54:13  thoth
//  chi_functions now return BitDIs.
//  more pointwise complex functions.

//  Revision 1.2  1993/12/29  17:27:24  thoth
//  reductions require a zero now.

//  Revision 1.1  1993/11/29  22:25:25  thoth
//  Initial revision

// include <complex.h>
#include "CplxDI.h"
#include "VectorI.h"
#include "ConstI.h"
#include "ImageIter.h"
#include "FBI.h"
#include "../valueset/OpTable.h"
//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// binary pointwise non-commutative operator- I(complex) I(complex) I(complex)
//
#ifndef BOT_complex_complex_complex_operatorIAOPmn
#define BOT_complex_complex_complex_operatorIAOPmn
IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, complex>*,
	IA_BaseImage<IA_Point<int>, complex>,
	IA_BaseImage<IA_Point<int>, complex> >
	*IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl;

void IA_fill_Image_IP_complex_complex_complex_operatorIAOPmn_tbl();

#endif // BOT_complex_complex_complex_operatorIAOPmn
IA_Image<IA_Point<int>, complex>
operator- ( const IA_Image<IA_Point<int>, complex> &lhs,
		const IA_Image<IA_Point<int>, complex> &rhs)
{
    if (lhs.domain() != rhs.domain()) {
	 IA_Image<IA_Point<int>, complex>	rval;
	ia_throw(Image_DomainMismatch_Exception(__FILE__,__LINE__));
	return rval;
    }

    if (!IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl)
	IA_fill_Image_IP_complex_complex_complex_operatorIAOPmn_tbl();

    IA_BaseImage<IA_Point<int>, complex>*(*f)( IA_BaseImage<IA_Point<int>, complex> &,
		IA_BaseImage<IA_Point<int>, complex> &);
    f = IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->lookup_operation
	(lhs.type(), rhs.type());
    IA_BaseImage<IA_Point<int>,complex>	&basel = *IA_FBI<IA_Point<int>,IA_Point<int>, complex,complex,complex>
	    ::extract_baseptr(lhs);
    IA_BaseImage<IA_Point<int>,complex>	&baser = *IA_FBI<IA_Point<int>,IA_Point<int>, complex,complex,complex>
	    ::extract_baseptr(rhs);
    return IA_Image<IA_Point<int>,complex>
	(IA_FBI<IA_Point<int>,IA_Point<int>, complex,complex,complex>
	 ::make_Image(	 f(basel,baser)));
}

//
//
//

static IA_BaseImage<IA_Point<int>, complex> *
vec_vec_bo_operatorIAOPmn(IA_BaseImage<IA_Point<int>, complex> &lhs_,
	IA_BaseImage<IA_Point<int>, complex> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    complex *const vec = new complex[sz];

    {
	complex *ds = vec;
	IA_VectorI<IA_Point<int>, complex> *lhs
		= (IA_VectorI<IA_Point<int>, complex> *)&lhs_;
	const complex *ls = lhs->vec;
	IA_VectorI<IA_Point<int>, complex> *rhs
		= (IA_VectorI<IA_Point<int>, complex> *)&rhs_;
	const complex *rs = rhs->vec;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = ( (*ls) - (*rs) );
	    ls++;
	    rs++;
	}
    }
    return new IA_VectorI<IA_Point<int>, complex>(domain, vec, sz, 1);
}

#ifndef vec_scalar_complex_complex_complex_operatorIAOPmn
#define vec_scalar_complex_complex_complex_operatorIAOPmn
static IA_BaseImage<IA_Point<int>, complex> *
vec_scalar_bo_operatorIAOPmn(IA_BaseImage<IA_Point<int>, complex> &lhs_,
	IA_BaseImage<IA_Point<int>, complex> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    complex *const vec = new complex[sz];

    {
	complex *ds = vec;
	IA_VectorI<IA_Point<int>, complex> *lhs
		= (IA_VectorI<IA_Point<int>, complex> *)&lhs_;
	const complex *ls = lhs->vec;
	IA_ConstI<IA_Point<int>, complex> *rhs
		= (IA_ConstI<IA_Point<int>, complex> *)&rhs_;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = ( (*ls) - (rhs->value) );
	    ls++;
	}
    }
    return new IA_VectorI<IA_Point<int>, complex>(domain, vec, sz, 1);
}
#endif // vec_scalar_complex_complex_complex_operatorIAOPmn

static IA_BaseImage<IA_Point<int>, complex> *
vec_iter_bo_operatorIAOPmn(IA_BaseImage<IA_Point<int>, complex> &lhs_,
	IA_BaseImage<IA_Point<int>, complex> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    complex *const vec = new complex[sz];

    {
	complex *ds = vec;
	IA_VectorI<IA_Point<int>, complex> *lhs
		= (IA_VectorI<IA_Point<int>, complex> *)&lhs_;
	const complex *ls = lhs->vec;
	complex rtmp;
	IA_BaseIVIter<IA_Point<int>, complex>	*riter = rhs_.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    riter->next(rtmp);
	    *(ds++) = ( (*ls) - (rtmp) );
	    ls++;
	}
	delete riter;
    }
    return new IA_VectorI<IA_Point<int>, complex>(domain, vec, sz, 1);
}

#ifndef scalar_vec_complex_complex_complex_operatorIAOPmn
#define scalar_vec_complex_complex_complex_operatorIAOPmn
static IA_BaseImage<IA_Point<int>, complex> *
scalar_vec_bo_operatorIAOPmn(IA_BaseImage<IA_Point<int>, complex> &lhs_,
	IA_BaseImage<IA_Point<int>, complex> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    complex *const vec = new complex[sz];

    {
	complex *ds = vec;
	IA_ConstI<IA_Point<int>, complex> *lhs
		= (IA_ConstI<IA_Point<int>, complex> *)&lhs_;
	IA_VectorI<IA_Point<int>, complex> *rhs
		= (IA_VectorI<IA_Point<int>, complex> *)&rhs_;
	const complex *rs = rhs->vec;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = ( (lhs->value) - (*rs) );
	    rs++;
	}
    }
    return new IA_VectorI<IA_Point<int>, complex>(domain, vec, sz, 1);
}
#endif // scalar_vec_complex_complex_complex_operatorIAOPmn

#ifndef scalar_scalar_complex_complex_complex_operatorIAOPmn
#define scalar_scalar_complex_complex_complex_operatorIAOPmn
static IA_BaseImage<IA_Point<int>, complex> *
scalar_scalar_bo_operatorIAOPmn(IA_BaseImage<IA_Point<int>, complex> &lhs_,
	IA_BaseImage<IA_Point<int>, complex> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
	IA_ConstI<IA_Point<int>, complex> *lhs
		= (IA_ConstI<IA_Point<int>, complex> *)&lhs_;
	IA_ConstI<IA_Point<int>, complex> *rhs
		= (IA_ConstI<IA_Point<int>, complex> *)&rhs_;
    complex	aval = ( lhs->value - rhs->value );
    return new IA_ConstI<IA_Point<int>, complex>(domain, aval);
}
#endif // scalar_scalar_complex_complex_complex_operatorIAOPmn

#ifndef scalar_iter_complex_complex_complex_operatorIAOPmn
#define scalar_iter_complex_complex_complex_operatorIAOPmn
static IA_BaseImage<IA_Point<int>, complex> *
scalar_iter_bo_operatorIAOPmn(IA_BaseImage<IA_Point<int>, complex> &lhs_,
	IA_BaseImage<IA_Point<int>, complex> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    complex *const vec = new complex[sz];

    {
	complex *ds = vec;
	IA_ConstI<IA_Point<int>, complex> *lhs
		= (IA_ConstI<IA_Point<int>, complex> *)&lhs_;
	complex rtmp;
	IA_BaseIVIter<IA_Point<int>, complex>	*riter = rhs_.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    riter->next(rtmp);
	    *(ds++) = ( (lhs->value) - (rtmp) );
	}
	delete riter;
    }
    return new IA_VectorI<IA_Point<int>, complex>(domain, vec, sz, 1);
}
#endif // scalar_iter_complex_complex_complex_operatorIAOPmn

static IA_BaseImage<IA_Point<int>, complex> *
iter_vec_bo_operatorIAOPmn(IA_BaseImage<IA_Point<int>, complex> &lhs_,
	IA_BaseImage<IA_Point<int>, complex> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    complex *const vec = new complex[sz];

    {
	complex *ds = vec;
	complex ltmp;
	IA_BaseIVIter<IA_Point<int>, complex>	*liter = lhs_.value_iterator();
	IA_VectorI<IA_Point<int>, complex> *rhs
		= (IA_VectorI<IA_Point<int>, complex> *)&rhs_;
	const complex *rs = rhs->vec;
	for (unsigned i=0; i<sz; i++) {
	    liter->next(ltmp);
	    *(ds++) = ( (ltmp) - (*rs) );
	    rs++;
	}
	delete liter;
    }
    return new IA_VectorI<IA_Point<int>, complex>(domain, vec, sz, 1);
}

#ifndef iter_scalar_complex_complex_complex_operatorIAOPmn
#define iter_scalar_complex_complex_complex_operatorIAOPmn
static IA_BaseImage<IA_Point<int>, complex> *
iter_scalar_bo_operatorIAOPmn(IA_BaseImage<IA_Point<int>, complex> &lhs_,
	IA_BaseImage<IA_Point<int>, complex> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    complex *const vec = new complex[sz];

    {
	complex *ds = vec;
	complex ltmp;
	IA_BaseIVIter<IA_Point<int>, complex>	*liter = lhs_.value_iterator();
	IA_ConstI<IA_Point<int>, complex> *rhs
		= (IA_ConstI<IA_Point<int>, complex> *)&rhs_;
	for (unsigned i=0; i<sz; i++) {
	    liter->next(ltmp);
	    *(ds++) = ( (ltmp) - (rhs->value) );
	}
	delete liter;
    }
    return new IA_VectorI<IA_Point<int>, complex>(domain, vec, sz, 1);
}
#endif // iter_scalar_complex_complex_complex_operatorIAOPmn

static IA_BaseImage<IA_Point<int>, complex> *
iter_iter_bo_operatorIAOPmn(IA_BaseImage<IA_Point<int>, complex> &lhs_,
	IA_BaseImage<IA_Point<int>, complex> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    complex *const vec = new complex[sz];

    {
	complex *ds = vec;
	complex ltmp;
	IA_BaseIVIter<IA_Point<int>, complex>	*liter = lhs_.value_iterator();
	complex rtmp;
	IA_BaseIVIter<IA_Point<int>, complex>	*riter = rhs_.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    liter->next(ltmp);
	    riter->next(rtmp);
	    *(ds++) = ( (ltmp) - (rtmp) );
	}
	delete liter;
	delete riter;
    }
    return new IA_VectorI<IA_Point<int>, complex>(domain, vec, sz, 1);
}

#ifndef FILL_BOT_complex_complex_complex_operatorIAOPmn
#define FILL_BOT_complex_complex_complex_operatorIAOPmn
void IA_fill_Image_IP_complex_complex_complex_operatorIAOPmn_tbl()
{
    if (IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl)
	return;

    IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, complex>*,
	IA_BaseImage<IA_Point<int>, complex>,
	IA_BaseImage<IA_Point<int>, complex> >::function f;
    f = iter_iter_bo_operatorIAOPmn;

    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl = new IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, complex>*,
	IA_BaseImage<IA_Point<int>, complex>,
	IA_BaseImage<IA_Point<int>, complex> >(iter_iter_bo_operatorIAOPmn);
    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->add_operation
	(IA_VectorI<IA_Point<int>, complex>::s_type(),
	 IA_VectorI<IA_Point<int>, complex>::s_type(),
	 vec_vec_bo_operatorIAOPmn);
    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->add_operation
	(IA_VectorI<IA_Point<int>, complex>::s_type(),
	 IA_ConstI<IA_Point<int>, complex>::s_type(),
	 vec_scalar_bo_operatorIAOPmn);
    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->add_operation
	(IA_VectorI<IA_Point<int>, complex>::s_type(),
	 0,
	 vec_iter_bo_operatorIAOPmn);

    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->add_operation
	(IA_ConstI<IA_Point<int>, complex>::s_type(),
	 IA_VectorI<IA_Point<int>, complex>::s_type(),
	 scalar_vec_bo_operatorIAOPmn);
    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->add_operation
	(IA_ConstI<IA_Point<int>, complex>::s_type(),
	 IA_ConstI<IA_Point<int>, complex>::s_type(),
	 scalar_scalar_bo_operatorIAOPmn);
    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->add_operation
	(IA_ConstI<IA_Point<int>, complex>::s_type(),
	 0,
	 scalar_iter_bo_operatorIAOPmn);

    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->add_operation
	(0,
	 IA_VectorI<IA_Point<int>, complex>::s_type(),
	 iter_vec_bo_operatorIAOPmn);
    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->add_operation
	(0,
	 IA_ConstI<IA_Point<int>, complex>::s_type(),
	 iter_scalar_bo_operatorIAOPmn);

}
#endif // BOT_complex_complex_complex_operatorIAOPmn

//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// binary pointwise non-commutative operator- I(complex) I(complex) complex
//
#ifndef BOT_complex_complex_complex_operatorIAOPmn
#define BOT_complex_complex_complex_operatorIAOPmn
IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, complex>*,
	IA_BaseImage<IA_Point<int>, complex>,
	IA_BaseImage<IA_Point<int>, complex> >
	*IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl;

void IA_fill_Image_IP_complex_complex_complex_operatorIAOPmn_tbl();

#endif // BOT_complex_complex_complex_operatorIAOPmn
IA_Image<IA_Point<int>, complex>
operator- ( const IA_Image<IA_Point<int>, complex> &lhs,
		complex rhs)
{
    if (!IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl)
	IA_fill_Image_IP_complex_complex_complex_operatorIAOPmn_tbl();

    IA_BaseImage<IA_Point<int>, complex>*(*f)( IA_BaseImage<IA_Point<int>, complex> &,
		IA_BaseImage<IA_Point<int>, complex> &);
    f = IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->lookup_operation
	(lhs.type(), IA_ConstI<IA_Point<int>, complex>::s_type());
    IA_BaseImage<IA_Point<int>,complex>	&basel = *IA_FBI<IA_Point<int>,IA_Point<int>, complex,complex,complex>
	    ::extract_baseptr(lhs);
    IA_ConstI<IA_Point<int>,complex>	baser(lhs.domain(), rhs);
    return IA_Image<IA_Point<int>,complex>
	(IA_FBI<IA_Point<int>,IA_Point<int>, complex,complex,complex>
	 ::make_Image(	 f(basel,baser)));
}

//
//
//

#ifndef vec_scalar_complex_complex_complex_operatorIAOPmn
#define vec_scalar_complex_complex_complex_operatorIAOPmn
static IA_BaseImage<IA_Point<int>, complex> *
vec_scalar_bo_operatorIAOPmn(IA_BaseImage<IA_Point<int>, complex> &lhs_,
	IA_BaseImage<IA_Point<int>, complex> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    complex *const vec = new complex[sz];

    {
	complex *ds = vec;
	IA_VectorI<IA_Point<int>, complex> *lhs
		= (IA_VectorI<IA_Point<int>, complex> *)&lhs_;
	const complex *ls = lhs->vec;
	IA_ConstI<IA_Point<int>, complex> *rhs
		= (IA_ConstI<IA_Point<int>, complex> *)&rhs_;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = ( (*ls) - (rhs->value) );
	    ls++;
	}
    }
    return new IA_VectorI<IA_Point<int>, complex>(domain, vec, sz, 1);
}
#endif // vec_scalar_complex_complex_complex_operatorIAOPmn

#ifndef scalar_scalar_complex_complex_complex_operatorIAOPmn
#define scalar_scalar_complex_complex_complex_operatorIAOPmn
static IA_BaseImage<IA_Point<int>, complex> *
scalar_scalar_bo_operatorIAOPmn(IA_BaseImage<IA_Point<int>, complex> &lhs_,
	IA_BaseImage<IA_Point<int>, complex> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
	IA_ConstI<IA_Point<int>, complex> *lhs
		= (IA_ConstI<IA_Point<int>, complex> *)&lhs_;
	IA_ConstI<IA_Point<int>, complex> *rhs
		= (IA_ConstI<IA_Point<int>, complex> *)&rhs_;
    complex	aval = ( lhs->value - rhs->value );
    return new IA_ConstI<IA_Point<int>, complex>(domain, aval);
}
#endif // scalar_scalar_complex_complex_complex_operatorIAOPmn

#ifndef iter_scalar_complex_complex_complex_operatorIAOPmn
#define iter_scalar_complex_complex_complex_operatorIAOPmn
static IA_BaseImage<IA_Point<int>, complex> *
iter_scalar_bo_operatorIAOPmn(IA_BaseImage<IA_Point<int>, complex> &lhs_,
	IA_BaseImage<IA_Point<int>, complex> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    complex *const vec = new complex[sz];

    {
	complex *ds = vec;
	complex ltmp;
	IA_BaseIVIter<IA_Point<int>, complex>	*liter = lhs_.value_iterator();
	IA_ConstI<IA_Point<int>, complex> *rhs
		= (IA_ConstI<IA_Point<int>, complex> *)&rhs_;
	for (unsigned i=0; i<sz; i++) {
	    liter->next(ltmp);
	    *(ds++) = ( (ltmp) - (rhs->value) );
	}
	delete liter;
    }
    return new IA_VectorI<IA_Point<int>, complex>(domain, vec, sz, 1);
}
#endif // iter_scalar_complex_complex_complex_operatorIAOPmn

#ifndef FILL_BOT_complex_complex_complex_operatorIAOPmn
#define FILL_BOT_complex_complex_complex_operatorIAOPmn
void IA_fill_Image_IP_complex_complex_complex_operatorIAOPmn_tbl()
{
    if (IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl)
	return;

    IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, complex>*,
	IA_BaseImage<IA_Point<int>, complex>,
	IA_BaseImage<IA_Point<int>, complex> >::function f;
    f = iter_iter_bo_operatorIAOPmn;

    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl = new IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, complex>*,
	IA_BaseImage<IA_Point<int>, complex>,
	IA_BaseImage<IA_Point<int>, complex> >(iter_iter_bo_operatorIAOPmn);
    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->add_operation
	(IA_VectorI<IA_Point<int>, complex>::s_type(),
	 IA_VectorI<IA_Point<int>, complex>::s_type(),
	 vec_vec_bo_operatorIAOPmn);
    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->add_operation
	(IA_VectorI<IA_Point<int>, complex>::s_type(),
	 IA_ConstI<IA_Point<int>, complex>::s_type(),
	 vec_scalar_bo_operatorIAOPmn);
    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->add_operation
	(IA_VectorI<IA_Point<int>, complex>::s_type(),
	 0,
	 vec_iter_bo_operatorIAOPmn);

    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->add_operation
	(IA_ConstI<IA_Point<int>, complex>::s_type(),
	 IA_VectorI<IA_Point<int>, complex>::s_type(),
	 scalar_vec_bo_operatorIAOPmn);
    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->add_operation
	(IA_ConstI<IA_Point<int>, complex>::s_type(),
	 IA_ConstI<IA_Point<int>, complex>::s_type(),
	 scalar_scalar_bo_operatorIAOPmn);
    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->add_operation
	(IA_ConstI<IA_Point<int>, complex>::s_type(),
	 0,
	 scalar_iter_bo_operatorIAOPmn);

    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->add_operation
	(0,
	 IA_VectorI<IA_Point<int>, complex>::s_type(),
	 iter_vec_bo_operatorIAOPmn);
    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->add_operation
	(0,
	 IA_ConstI<IA_Point<int>, complex>::s_type(),
	 iter_scalar_bo_operatorIAOPmn);

}
#endif // BOT_complex_complex_complex_operatorIAOPmn

//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// binary pointwise non-commutative operator- I(complex) complex I(complex)
//
#ifndef BOT_complex_complex_complex_operatorIAOPmn
#define BOT_complex_complex_complex_operatorIAOPmn
IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, complex>*,
	IA_BaseImage<IA_Point<int>, complex>,
	IA_BaseImage<IA_Point<int>, complex> >
	*IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl;

void IA_fill_Image_IP_complex_complex_complex_operatorIAOPmn_tbl();

#endif // BOT_complex_complex_complex_operatorIAOPmn
IA_Image<IA_Point<int>, complex>
operator- ( complex lhs,
		const IA_Image<IA_Point<int>, complex> &rhs)
{
    if (!IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl)
	IA_fill_Image_IP_complex_complex_complex_operatorIAOPmn_tbl();

    IA_BaseImage<IA_Point<int>, complex>*(*f)( IA_BaseImage<IA_Point<int>, complex> &,
		IA_BaseImage<IA_Point<int>, complex> &);
    f = IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->lookup_operation
	(IA_ConstI<IA_Point<int>, complex>::s_type(), rhs.type());
    IA_ConstI<IA_Point<int>,complex>	basel(rhs.domain(), lhs);
    IA_BaseImage<IA_Point<int>,complex>	&baser = *IA_FBI<IA_Point<int>,IA_Point<int>, complex,complex,complex>
	    ::extract_baseptr(rhs);
    return IA_Image<IA_Point<int>,complex>
	(IA_FBI<IA_Point<int>,IA_Point<int>, complex,complex,complex>
	 ::make_Image(	 f(basel,baser)));
}

//
//
//

#ifndef scalar_vec_complex_complex_complex_operatorIAOPmn
#define scalar_vec_complex_complex_complex_operatorIAOPmn
static IA_BaseImage<IA_Point<int>, complex> *
scalar_vec_bo_operatorIAOPmn(IA_BaseImage<IA_Point<int>, complex> &lhs_,
	IA_BaseImage<IA_Point<int>, complex> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    complex *const vec = new complex[sz];

    {
	complex *ds = vec;
	IA_ConstI<IA_Point<int>, complex> *lhs
		= (IA_ConstI<IA_Point<int>, complex> *)&lhs_;
	IA_VectorI<IA_Point<int>, complex> *rhs
		= (IA_VectorI<IA_Point<int>, complex> *)&rhs_;
	const complex *rs = rhs->vec;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = ( (lhs->value) - (*rs) );
	    rs++;
	}
    }
    return new IA_VectorI<IA_Point<int>, complex>(domain, vec, sz, 1);
}
#endif // scalar_vec_complex_complex_complex_operatorIAOPmn

#ifndef scalar_scalar_complex_complex_complex_operatorIAOPmn
#define scalar_scalar_complex_complex_complex_operatorIAOPmn
static IA_BaseImage<IA_Point<int>, complex> *
scalar_scalar_bo_operatorIAOPmn(IA_BaseImage<IA_Point<int>, complex> &lhs_,
	IA_BaseImage<IA_Point<int>, complex> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
	IA_ConstI<IA_Point<int>, complex> *lhs
		= (IA_ConstI<IA_Point<int>, complex> *)&lhs_;
	IA_ConstI<IA_Point<int>, complex> *rhs
		= (IA_ConstI<IA_Point<int>, complex> *)&rhs_;
    complex	aval = ( lhs->value - rhs->value );
    return new IA_ConstI<IA_Point<int>, complex>(domain, aval);
}
#endif // scalar_scalar_complex_complex_complex_operatorIAOPmn

#ifndef scalar_iter_complex_complex_complex_operatorIAOPmn
#define scalar_iter_complex_complex_complex_operatorIAOPmn
static IA_BaseImage<IA_Point<int>, complex> *
scalar_iter_bo_operatorIAOPmn(IA_BaseImage<IA_Point<int>, complex> &lhs_,
	IA_BaseImage<IA_Point<int>, complex> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    complex *const vec = new complex[sz];

    {
	complex *ds = vec;
	IA_ConstI<IA_Point<int>, complex> *lhs
		= (IA_ConstI<IA_Point<int>, complex> *)&lhs_;
	complex rtmp;
	IA_BaseIVIter<IA_Point<int>, complex>	*riter = rhs_.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    riter->next(rtmp);
	    *(ds++) = ( (lhs->value) - (rtmp) );
	}
	delete riter;
    }
    return new IA_VectorI<IA_Point<int>, complex>(domain, vec, sz, 1);
}
#endif // scalar_iter_complex_complex_complex_operatorIAOPmn

#ifndef FILL_BOT_complex_complex_complex_operatorIAOPmn
#define FILL_BOT_complex_complex_complex_operatorIAOPmn
void IA_fill_Image_IP_complex_complex_complex_operatorIAOPmn_tbl()
{
    if (IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl)
	return;

    IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, complex>*,
	IA_BaseImage<IA_Point<int>, complex>,
	IA_BaseImage<IA_Point<int>, complex> >::function f;
    f = iter_iter_bo_operatorIAOPmn;

    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl = new IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, complex>*,
	IA_BaseImage<IA_Point<int>, complex>,
	IA_BaseImage<IA_Point<int>, complex> >(iter_iter_bo_operatorIAOPmn);
    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->add_operation
	(IA_VectorI<IA_Point<int>, complex>::s_type(),
	 IA_VectorI<IA_Point<int>, complex>::s_type(),
	 vec_vec_bo_operatorIAOPmn);
    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->add_operation
	(IA_VectorI<IA_Point<int>, complex>::s_type(),
	 IA_ConstI<IA_Point<int>, complex>::s_type(),
	 vec_scalar_bo_operatorIAOPmn);
    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->add_operation
	(IA_VectorI<IA_Point<int>, complex>::s_type(),
	 0,
	 vec_iter_bo_operatorIAOPmn);

    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->add_operation
	(IA_ConstI<IA_Point<int>, complex>::s_type(),
	 IA_VectorI<IA_Point<int>, complex>::s_type(),
	 scalar_vec_bo_operatorIAOPmn);
    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->add_operation
	(IA_ConstI<IA_Point<int>, complex>::s_type(),
	 IA_ConstI<IA_Point<int>, complex>::s_type(),
	 scalar_scalar_bo_operatorIAOPmn);
    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->add_operation
	(IA_ConstI<IA_Point<int>, complex>::s_type(),
	 0,
	 scalar_iter_bo_operatorIAOPmn);

    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->add_operation
	(0,
	 IA_VectorI<IA_Point<int>, complex>::s_type(),
	 iter_vec_bo_operatorIAOPmn);
    IA_Image_IP_complex_complex_complex_operatorIAOPmn_tbl->add_operation
	(0,
	 IA_ConstI<IA_Point<int>, complex>::s_type(),
	 iter_scalar_bo_operatorIAOPmn);

}
#endif // BOT_complex_complex_complex_operatorIAOPmn

//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// unary pointwise operator- I(complex) I(complex)
//
// Emacs: -*- C++ -*-

//
//	Copyright 1993, Center for Computer Vision and Visualization,
//	University of Florida.  All rights reserved.
//


//
// $Log: unary-op.templ,v $
// Revision 1.4.1.2  1995/01/13  19:37:42  thoth
// CoreImage has been re-merged with Image.  All special stuff should be
// friends of FBI now.
//
// Revision 1.4.1.1  1994/12/28  17:22:11  thoth
// image operations are friends of FBI now.
//
// Revision 1.4  1994/07/25  17:26:39  thoth
// Name sanitization
//
// Revision 1.3  1994/01/07  15:15:14  thoth
// Image class is now CoreImage and named image types are
// Image<P,T>.
//
// Revision 1.2  1993/12/29  17:33:18  thoth
// New operator scheme that prevents the need for trivial Image conversions.
//
// Revision 1.1  1993/09/15  13:07:16  thoth
// Initial revision
//
// Revision 1.2  93/05/27  11:49:04  thoth
// Copyright Notices
// 
// Revision 1.1  93/03/10  13:50:00  thoth
// Initial revision
// 

#ifndef UOT_complex_complex_operatorIAOPmn
#define UOT_complex_complex_operatorIAOPmn
IA_UnaryOperationsTable<IA_BaseImage<IA_Point<int>, complex>*,
	IA_BaseImage<IA_Point<int>, complex> >
	*IA_Image_IP_complex_complex_operatorIAOPmn_tbl;

void IA_fill_Image_IP_complex_complex_operatorIAOPmn_tbl();
#endif


IA_Image<IA_Point<int>, complex>
operator- ( const IA_Image<IA_Point<int>, complex> &arg)
{
    if (!IA_Image_IP_complex_complex_operatorIAOPmn_tbl)
	IA_fill_Image_IP_complex_complex_operatorIAOPmn_tbl();

    IA_BaseImage<IA_Point<int>, complex>*(*f)
	(IA_BaseImage<IA_Point<int>, complex> &);
    f = IA_Image_IP_complex_complex_operatorIAOPmn_tbl->lookup_operation (arg.type());

    
    IA_BaseImage<IA_Point<int>, complex>	&bip =
	*IA_FBI<IA_Point<int>,IA_Point<int>,complex,complex,complex>
	    ::extract_baseptr(arg);

    return IA_FBI<IA_Point<int>,IA_Point<int>, complex,complex,complex>
	 ::make_Image(f(bip));
}

#ifndef vec_uop_complex_complex_operatorIAOPmn
#define vec_uop_complex_complex_operatorIAOPmn
static IA_BaseImage<IA_Point<int>, complex>*
vec_uo_operatorIAOPmn(IA_BaseImage<IA_Point<int>, complex> &lhs_)
{
    const IA_VectorI<IA_Point<int>, complex> *lhs =
	(IA_VectorI<IA_Point<int>, complex> *) &lhs_;

    const IA_Set<IA_Point<int> > domain = lhs->domain();
    const unsigned sz = domain.card();
    complex *const vec = new complex[sz];

    {
	complex *ds = vec;
	const complex *ls = lhs->vec;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = -(*(ls++));
	}
    }
    return new IA_VectorI<IA_Point<int>, complex>(domain, vec, sz, 1);
}
#endif // vec_uop_complex_complex_operatorIAOPmn

#ifndef scalar_uop_complex_complex_operatorIAOPmn
#define scalar_uop_complex_complex_operatorIAOPmn
static IA_BaseImage<IA_Point<int>, complex>*
scalar_uo_operatorIAOPmn(IA_BaseImage<IA_Point<int>, complex> &lhs_)
{
    const IA_ConstI<IA_Point<int>, complex> *lhs =
	(IA_ConstI<IA_Point<int>, complex> *) &lhs_;

    const IA_Set<IA_Point<int> > domain = lhs->domain();

    return new IA_ConstI<IA_Point<int>, complex>(domain, -(lhs->value));
}
#endif // scalar_uop_complex_complex_operatorIAOPmn

// scalar-scalar operation is trivial

#ifndef iter_uop_complex_complex_operatorIAOPmn
#define iter_uop_complex_complex_operatorIAOPmn
static IA_BaseImage<IA_Point<int>, complex>*
iter_uo_operatorIAOPmn(IA_BaseImage<IA_Point<int>, complex> &lhs)
{
    const IA_Set<IA_Point<int> > domain = lhs.domain();
    const unsigned sz = domain.card();
    complex *const vec = new complex[sz];

    {
	complex *ds = vec;
	complex ltmp;
	IA_BaseIVIter<IA_Point<int>, complex>	*liter = lhs.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    liter->next(ltmp);
	    *(ds++) = -(ltmp);
	}
	delete liter;
    }
    return new IA_VectorI<IA_Point<int>, complex>(domain, vec, sz, 1);
}
#endif // iter_uop_complex_complex_operatorIAOPmn

#ifndef FILL_UOT_complex_complex_operatorIAOPmn
#define FILL_UOT_complex_complex_operatorIAOPmn
void IA_fill_Image_IP_complex_complex_operatorIAOPmn_tbl()
{
    if (IA_Image_IP_complex_complex_operatorIAOPmn_tbl)
	return;

    IA_UnaryOperationsTable<IA_BaseImage<IA_Point<int>, complex>*,
	IA_BaseImage<IA_Point<int>, complex> >::function f;
    f = iter_uo_operatorIAOPmn;

    IA_Image_IP_complex_complex_operatorIAOPmn_tbl = new IA_UnaryOperationsTable<IA_BaseImage<IA_Point<int>, complex>*,
	IA_BaseImage<IA_Point<int>, complex> >(iter_uo_operatorIAOPmn);
    IA_Image_IP_complex_complex_operatorIAOPmn_tbl->add_operation
	(IA_VectorI<IA_Point<int>, complex>::s_type(),
	 vec_uo_operatorIAOPmn);
    IA_Image_IP_complex_complex_operatorIAOPmn_tbl->add_operation
	(IA_ConstI<IA_Point<int>, complex>::s_type(),
	 scalar_uo_operatorIAOPmn);

}
#endif // UOT_complex_complex_operatorIAOPmn

//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// pointwise operator-= I(complex) I(complex)
//
// There are none (it's inline)

//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// pointwise operator-= I(complex) complex
//
// There are none (it's inline)

//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// filename CIO-__ml.c
//
