// Emacs -*- C++ -*-

// Machine generated include file, do not modify.


// 	Copyright 1993, Center for Computer Vision and Visualization,
// 	University of Florida.  All rights reserved.


//  $Log: float-operations.desc,v $
//  Revision 1.11.1.2  1995/01/31  16:02:40  thoth
//  Need to replace the upward conversions with something...

//  Revision 1.11.1.1  1994/12/28  18:05:25  thoth
//  image operations are now friendly with FBI.
//  image ops now use operations table
//  new sgn() function.

//  Revision 1.11  1994/12/19  19:58:48  ljr
//  DOS-inspired name rework.

//  Revision 1.10  1994/10/14  20:43:19  thoth
//  The inline is much more useful in the header file.

//  Revision 1.9  1994/09/16  14:59:10  thoth
//  add fabs(image)

//  Revision 1.8  1994/07/08  16:14:11  thoth
//  fixed problems caused by returning floats instead of doubles.

//  Revision 1.7  1994/05/17  12:54:56  thoth
//  Improved operations generation scheme.  Lines from the op.desc file can
//  be quoted into the .c file to allow inclusion of infrastructure.  Also
//  the op.desc output can be redirected to several files.  The prefix
//  directive allows common information (include files) to be included in
//  every generated source file.

//  Float operations for the Float Discrete Image
#include "FloatDI.h"
#include "VectorI.h"
#include "ConstI.h"
#include "ImageIter.h"
#include "FBI.h"
#include "../valueset/OpTable.h"
//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// binary pointwise non-commutative chi_ge subop=operator>= I(IA_Bit) I(float) I(float)
//
#ifndef BOT_IA_Bit_float_float_chi_ge
#define BOT_IA_Bit_float_float_chi_ge
IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, IA_Bit>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >
	*IA_Image_IP_IA_Bit_float_float_chi_ge_tbl;

void IA_fill_Image_IP_IA_Bit_float_float_chi_ge_tbl();

#endif // BOT_IA_Bit_float_float_chi_ge
IA_Image<IA_Point<int>, IA_Bit>
chi_ge ( const IA_Image<IA_Point<int>, float> &lhs,
		const IA_Image<IA_Point<int>, float> &rhs)
{
    if (lhs.domain() != rhs.domain()) {
	 IA_Image<IA_Point<int>, IA_Bit>	rval;
	ia_throw(Image_DomainMismatch_Exception(__FILE__,__LINE__));
	return rval;
    }

    if (!IA_Image_IP_IA_Bit_float_float_chi_ge_tbl)
	IA_fill_Image_IP_IA_Bit_float_float_chi_ge_tbl();

    IA_BaseImage<IA_Point<int>, IA_Bit>*(*f)( IA_BaseImage<IA_Point<int>, float> &,
		IA_BaseImage<IA_Point<int>, float> &);
    f = IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->lookup_operation
	(lhs.type(), rhs.type());
    IA_BaseImage<IA_Point<int>,float>	&basel = *IA_FBI<IA_Point<int>,IA_Point<int>, float,float,float>
	    ::extract_baseptr(lhs);
    IA_BaseImage<IA_Point<int>,float>	&baser = *IA_FBI<IA_Point<int>,IA_Point<int>, float,float,float>
	    ::extract_baseptr(rhs);
    return IA_Image<IA_Point<int>,IA_Bit>
	(IA_FBI<IA_Point<int>,IA_Point<int>, IA_Bit,IA_Bit,IA_Bit>
	 ::make_Image(	 f(basel,baser)));
}

//
//
//

static IA_BaseImage<IA_Point<int>, IA_Bit> *
vec_vec_bo_chi_ge(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    IA_Bit *const vec = new IA_Bit[sz];

    {
	IA_Bit *ds = vec;
	IA_VectorI<IA_Point<int>, float> *lhs
		= (IA_VectorI<IA_Point<int>, float> *)&lhs_;
	const float *ls = lhs->vec;
	IA_VectorI<IA_Point<int>, float> *rhs
		= (IA_VectorI<IA_Point<int>, float> *)&rhs_;
	const float *rs = rhs->vec;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = ( (*ls) >= (*rs) );
	    ls++;
	    rs++;
	}
    }
    return new IA_VectorI<IA_Point<int>, IA_Bit>(domain, vec, sz, 1);
}

#ifndef vec_scalar_IA_Bit_float_float_chi_ge
#define vec_scalar_IA_Bit_float_float_chi_ge
static IA_BaseImage<IA_Point<int>, IA_Bit> *
vec_scalar_bo_chi_ge(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    IA_Bit *const vec = new IA_Bit[sz];

    {
	IA_Bit *ds = vec;
	IA_VectorI<IA_Point<int>, float> *lhs
		= (IA_VectorI<IA_Point<int>, float> *)&lhs_;
	const float *ls = lhs->vec;
	IA_ConstI<IA_Point<int>, float> *rhs
		= (IA_ConstI<IA_Point<int>, float> *)&rhs_;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = ( (*ls) >= (rhs->value) );
	    ls++;
	}
    }
    return new IA_VectorI<IA_Point<int>, IA_Bit>(domain, vec, sz, 1);
}
#endif // vec_scalar_IA_Bit_float_float_chi_ge

static IA_BaseImage<IA_Point<int>, IA_Bit> *
vec_iter_bo_chi_ge(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    IA_Bit *const vec = new IA_Bit[sz];

    {
	IA_Bit *ds = vec;
	IA_VectorI<IA_Point<int>, float> *lhs
		= (IA_VectorI<IA_Point<int>, float> *)&lhs_;
	const float *ls = lhs->vec;
	float rtmp;
	IA_BaseIVIter<IA_Point<int>, float>	*riter = rhs_.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    riter->next(rtmp);
	    *(ds++) = ( (*ls) >= (rtmp) );
	    ls++;
	}
	delete riter;
    }
    return new IA_VectorI<IA_Point<int>, IA_Bit>(domain, vec, sz, 1);
}

#ifndef scalar_vec_IA_Bit_float_float_chi_ge
#define scalar_vec_IA_Bit_float_float_chi_ge
static IA_BaseImage<IA_Point<int>, IA_Bit> *
scalar_vec_bo_chi_ge(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    IA_Bit *const vec = new IA_Bit[sz];

    {
	IA_Bit *ds = vec;
	IA_ConstI<IA_Point<int>, float> *lhs
		= (IA_ConstI<IA_Point<int>, float> *)&lhs_;
	IA_VectorI<IA_Point<int>, float> *rhs
		= (IA_VectorI<IA_Point<int>, float> *)&rhs_;
	const float *rs = rhs->vec;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = ( (lhs->value) >= (*rs) );
	    rs++;
	}
    }
    return new IA_VectorI<IA_Point<int>, IA_Bit>(domain, vec, sz, 1);
}
#endif // scalar_vec_IA_Bit_float_float_chi_ge

#ifndef scalar_scalar_IA_Bit_float_float_chi_ge
#define scalar_scalar_IA_Bit_float_float_chi_ge
static IA_BaseImage<IA_Point<int>, IA_Bit> *
scalar_scalar_bo_chi_ge(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
	IA_ConstI<IA_Point<int>, float> *lhs
		= (IA_ConstI<IA_Point<int>, float> *)&lhs_;
	IA_ConstI<IA_Point<int>, float> *rhs
		= (IA_ConstI<IA_Point<int>, float> *)&rhs_;
    IA_Bit	aval = ( lhs->value >= rhs->value );
    return new IA_ConstI<IA_Point<int>, IA_Bit>(domain, aval);
}
#endif // scalar_scalar_IA_Bit_float_float_chi_ge

#ifndef scalar_iter_IA_Bit_float_float_chi_ge
#define scalar_iter_IA_Bit_float_float_chi_ge
static IA_BaseImage<IA_Point<int>, IA_Bit> *
scalar_iter_bo_chi_ge(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    IA_Bit *const vec = new IA_Bit[sz];

    {
	IA_Bit *ds = vec;
	IA_ConstI<IA_Point<int>, float> *lhs
		= (IA_ConstI<IA_Point<int>, float> *)&lhs_;
	float rtmp;
	IA_BaseIVIter<IA_Point<int>, float>	*riter = rhs_.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    riter->next(rtmp);
	    *(ds++) = ( (lhs->value) >= (rtmp) );
	}
	delete riter;
    }
    return new IA_VectorI<IA_Point<int>, IA_Bit>(domain, vec, sz, 1);
}
#endif // scalar_iter_IA_Bit_float_float_chi_ge

static IA_BaseImage<IA_Point<int>, IA_Bit> *
iter_vec_bo_chi_ge(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    IA_Bit *const vec = new IA_Bit[sz];

    {
	IA_Bit *ds = vec;
	float ltmp;
	IA_BaseIVIter<IA_Point<int>, float>	*liter = lhs_.value_iterator();
	IA_VectorI<IA_Point<int>, float> *rhs
		= (IA_VectorI<IA_Point<int>, float> *)&rhs_;
	const float *rs = rhs->vec;
	for (unsigned i=0; i<sz; i++) {
	    liter->next(ltmp);
	    *(ds++) = ( (ltmp) >= (*rs) );
	    rs++;
	}
	delete liter;
    }
    return new IA_VectorI<IA_Point<int>, IA_Bit>(domain, vec, sz, 1);
}

#ifndef iter_scalar_IA_Bit_float_float_chi_ge
#define iter_scalar_IA_Bit_float_float_chi_ge
static IA_BaseImage<IA_Point<int>, IA_Bit> *
iter_scalar_bo_chi_ge(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    IA_Bit *const vec = new IA_Bit[sz];

    {
	IA_Bit *ds = vec;
	float ltmp;
	IA_BaseIVIter<IA_Point<int>, float>	*liter = lhs_.value_iterator();
	IA_ConstI<IA_Point<int>, float> *rhs
		= (IA_ConstI<IA_Point<int>, float> *)&rhs_;
	for (unsigned i=0; i<sz; i++) {
	    liter->next(ltmp);
	    *(ds++) = ( (ltmp) >= (rhs->value) );
	}
	delete liter;
    }
    return new IA_VectorI<IA_Point<int>, IA_Bit>(domain, vec, sz, 1);
}
#endif // iter_scalar_IA_Bit_float_float_chi_ge

static IA_BaseImage<IA_Point<int>, IA_Bit> *
iter_iter_bo_chi_ge(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    IA_Bit *const vec = new IA_Bit[sz];

    {
	IA_Bit *ds = vec;
	float ltmp;
	IA_BaseIVIter<IA_Point<int>, float>	*liter = lhs_.value_iterator();
	float rtmp;
	IA_BaseIVIter<IA_Point<int>, float>	*riter = rhs_.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    liter->next(ltmp);
	    riter->next(rtmp);
	    *(ds++) = ( (ltmp) >= (rtmp) );
	}
	delete liter;
	delete riter;
    }
    return new IA_VectorI<IA_Point<int>, IA_Bit>(domain, vec, sz, 1);
}

#ifndef FILL_BOT_IA_Bit_float_float_chi_ge
#define FILL_BOT_IA_Bit_float_float_chi_ge
void IA_fill_Image_IP_IA_Bit_float_float_chi_ge_tbl()
{
    if (IA_Image_IP_IA_Bit_float_float_chi_ge_tbl)
	return;

    IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, IA_Bit>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >::function f;
    f = iter_iter_bo_chi_ge;

    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl = new IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, IA_Bit>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >(iter_iter_bo_chi_ge);
    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 vec_vec_bo_chi_ge);
    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 vec_scalar_bo_chi_ge);
    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 0,
	 vec_iter_bo_chi_ge);

    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 scalar_vec_bo_chi_ge);
    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 scalar_scalar_bo_chi_ge);
    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 0,
	 scalar_iter_bo_chi_ge);

    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->add_operation
	(0,
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 iter_vec_bo_chi_ge);
    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->add_operation
	(0,
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 iter_scalar_bo_chi_ge);

}
#endif // BOT_IA_Bit_float_float_chi_ge

//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// binary pointwise non-commutative chi_ge subop=operator>= I(IA_Bit) I(float) float
//
#ifndef BOT_IA_Bit_float_float_chi_ge
#define BOT_IA_Bit_float_float_chi_ge
IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, IA_Bit>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >
	*IA_Image_IP_IA_Bit_float_float_chi_ge_tbl;

void IA_fill_Image_IP_IA_Bit_float_float_chi_ge_tbl();

#endif // BOT_IA_Bit_float_float_chi_ge
IA_Image<IA_Point<int>, IA_Bit>
chi_ge ( const IA_Image<IA_Point<int>, float> &lhs,
		float rhs)
{
    if (!IA_Image_IP_IA_Bit_float_float_chi_ge_tbl)
	IA_fill_Image_IP_IA_Bit_float_float_chi_ge_tbl();

    IA_BaseImage<IA_Point<int>, IA_Bit>*(*f)( IA_BaseImage<IA_Point<int>, float> &,
		IA_BaseImage<IA_Point<int>, float> &);
    f = IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->lookup_operation
	(lhs.type(), IA_ConstI<IA_Point<int>, float>::s_type());
    IA_BaseImage<IA_Point<int>,float>	&basel = *IA_FBI<IA_Point<int>,IA_Point<int>, float,float,float>
	    ::extract_baseptr(lhs);
    IA_ConstI<IA_Point<int>,float>	baser(lhs.domain(), rhs);
    return IA_Image<IA_Point<int>,IA_Bit>
	(IA_FBI<IA_Point<int>,IA_Point<int>, IA_Bit,IA_Bit,IA_Bit>
	 ::make_Image(	 f(basel,baser)));
}

//
//
//

#ifndef vec_scalar_IA_Bit_float_float_chi_ge
#define vec_scalar_IA_Bit_float_float_chi_ge
static IA_BaseImage<IA_Point<int>, IA_Bit> *
vec_scalar_bo_chi_ge(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    IA_Bit *const vec = new IA_Bit[sz];

    {
	IA_Bit *ds = vec;
	IA_VectorI<IA_Point<int>, float> *lhs
		= (IA_VectorI<IA_Point<int>, float> *)&lhs_;
	const float *ls = lhs->vec;
	IA_ConstI<IA_Point<int>, float> *rhs
		= (IA_ConstI<IA_Point<int>, float> *)&rhs_;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = ( (*ls) >= (rhs->value) );
	    ls++;
	}
    }
    return new IA_VectorI<IA_Point<int>, IA_Bit>(domain, vec, sz, 1);
}
#endif // vec_scalar_IA_Bit_float_float_chi_ge

#ifndef scalar_scalar_IA_Bit_float_float_chi_ge
#define scalar_scalar_IA_Bit_float_float_chi_ge
static IA_BaseImage<IA_Point<int>, IA_Bit> *
scalar_scalar_bo_chi_ge(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
	IA_ConstI<IA_Point<int>, float> *lhs
		= (IA_ConstI<IA_Point<int>, float> *)&lhs_;
	IA_ConstI<IA_Point<int>, float> *rhs
		= (IA_ConstI<IA_Point<int>, float> *)&rhs_;
    IA_Bit	aval = ( lhs->value >= rhs->value );
    return new IA_ConstI<IA_Point<int>, IA_Bit>(domain, aval);
}
#endif // scalar_scalar_IA_Bit_float_float_chi_ge

#ifndef iter_scalar_IA_Bit_float_float_chi_ge
#define iter_scalar_IA_Bit_float_float_chi_ge
static IA_BaseImage<IA_Point<int>, IA_Bit> *
iter_scalar_bo_chi_ge(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    IA_Bit *const vec = new IA_Bit[sz];

    {
	IA_Bit *ds = vec;
	float ltmp;
	IA_BaseIVIter<IA_Point<int>, float>	*liter = lhs_.value_iterator();
	IA_ConstI<IA_Point<int>, float> *rhs
		= (IA_ConstI<IA_Point<int>, float> *)&rhs_;
	for (unsigned i=0; i<sz; i++) {
	    liter->next(ltmp);
	    *(ds++) = ( (ltmp) >= (rhs->value) );
	}
	delete liter;
    }
    return new IA_VectorI<IA_Point<int>, IA_Bit>(domain, vec, sz, 1);
}
#endif // iter_scalar_IA_Bit_float_float_chi_ge

#ifndef FILL_BOT_IA_Bit_float_float_chi_ge
#define FILL_BOT_IA_Bit_float_float_chi_ge
void IA_fill_Image_IP_IA_Bit_float_float_chi_ge_tbl()
{
    if (IA_Image_IP_IA_Bit_float_float_chi_ge_tbl)
	return;

    IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, IA_Bit>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >::function f;
    f = iter_iter_bo_chi_ge;

    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl = new IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, IA_Bit>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >(iter_iter_bo_chi_ge);
    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 vec_vec_bo_chi_ge);
    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 vec_scalar_bo_chi_ge);
    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 0,
	 vec_iter_bo_chi_ge);

    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 scalar_vec_bo_chi_ge);
    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 scalar_scalar_bo_chi_ge);
    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 0,
	 scalar_iter_bo_chi_ge);

    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->add_operation
	(0,
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 iter_vec_bo_chi_ge);
    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->add_operation
	(0,
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 iter_scalar_bo_chi_ge);

}
#endif // BOT_IA_Bit_float_float_chi_ge

//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// binary pointwise non-commutative chi_ge subop=operator>= I(IA_Bit) float I(float)
//
#ifndef BOT_IA_Bit_float_float_chi_ge
#define BOT_IA_Bit_float_float_chi_ge
IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, IA_Bit>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >
	*IA_Image_IP_IA_Bit_float_float_chi_ge_tbl;

void IA_fill_Image_IP_IA_Bit_float_float_chi_ge_tbl();

#endif // BOT_IA_Bit_float_float_chi_ge
IA_Image<IA_Point<int>, IA_Bit>
chi_ge ( float lhs,
		const IA_Image<IA_Point<int>, float> &rhs)
{
    if (!IA_Image_IP_IA_Bit_float_float_chi_ge_tbl)
	IA_fill_Image_IP_IA_Bit_float_float_chi_ge_tbl();

    IA_BaseImage<IA_Point<int>, IA_Bit>*(*f)( IA_BaseImage<IA_Point<int>, float> &,
		IA_BaseImage<IA_Point<int>, float> &);
    f = IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->lookup_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(), rhs.type());
    IA_ConstI<IA_Point<int>,float>	basel(rhs.domain(), lhs);
    IA_BaseImage<IA_Point<int>,float>	&baser = *IA_FBI<IA_Point<int>,IA_Point<int>, float,float,float>
	    ::extract_baseptr(rhs);
    return IA_Image<IA_Point<int>,IA_Bit>
	(IA_FBI<IA_Point<int>,IA_Point<int>, IA_Bit,IA_Bit,IA_Bit>
	 ::make_Image(	 f(basel,baser)));
}

//
//
//

#ifndef scalar_vec_IA_Bit_float_float_chi_ge
#define scalar_vec_IA_Bit_float_float_chi_ge
static IA_BaseImage<IA_Point<int>, IA_Bit> *
scalar_vec_bo_chi_ge(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    IA_Bit *const vec = new IA_Bit[sz];

    {
	IA_Bit *ds = vec;
	IA_ConstI<IA_Point<int>, float> *lhs
		= (IA_ConstI<IA_Point<int>, float> *)&lhs_;
	IA_VectorI<IA_Point<int>, float> *rhs
		= (IA_VectorI<IA_Point<int>, float> *)&rhs_;
	const float *rs = rhs->vec;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = ( (lhs->value) >= (*rs) );
	    rs++;
	}
    }
    return new IA_VectorI<IA_Point<int>, IA_Bit>(domain, vec, sz, 1);
}
#endif // scalar_vec_IA_Bit_float_float_chi_ge

#ifndef scalar_scalar_IA_Bit_float_float_chi_ge
#define scalar_scalar_IA_Bit_float_float_chi_ge
static IA_BaseImage<IA_Point<int>, IA_Bit> *
scalar_scalar_bo_chi_ge(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
	IA_ConstI<IA_Point<int>, float> *lhs
		= (IA_ConstI<IA_Point<int>, float> *)&lhs_;
	IA_ConstI<IA_Point<int>, float> *rhs
		= (IA_ConstI<IA_Point<int>, float> *)&rhs_;
    IA_Bit	aval = ( lhs->value >= rhs->value );
    return new IA_ConstI<IA_Point<int>, IA_Bit>(domain, aval);
}
#endif // scalar_scalar_IA_Bit_float_float_chi_ge

#ifndef scalar_iter_IA_Bit_float_float_chi_ge
#define scalar_iter_IA_Bit_float_float_chi_ge
static IA_BaseImage<IA_Point<int>, IA_Bit> *
scalar_iter_bo_chi_ge(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    IA_Bit *const vec = new IA_Bit[sz];

    {
	IA_Bit *ds = vec;
	IA_ConstI<IA_Point<int>, float> *lhs
		= (IA_ConstI<IA_Point<int>, float> *)&lhs_;
	float rtmp;
	IA_BaseIVIter<IA_Point<int>, float>	*riter = rhs_.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    riter->next(rtmp);
	    *(ds++) = ( (lhs->value) >= (rtmp) );
	}
	delete riter;
    }
    return new IA_VectorI<IA_Point<int>, IA_Bit>(domain, vec, sz, 1);
}
#endif // scalar_iter_IA_Bit_float_float_chi_ge

#ifndef FILL_BOT_IA_Bit_float_float_chi_ge
#define FILL_BOT_IA_Bit_float_float_chi_ge
void IA_fill_Image_IP_IA_Bit_float_float_chi_ge_tbl()
{
    if (IA_Image_IP_IA_Bit_float_float_chi_ge_tbl)
	return;

    IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, IA_Bit>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >::function f;
    f = iter_iter_bo_chi_ge;

    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl = new IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, IA_Bit>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >(iter_iter_bo_chi_ge);
    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 vec_vec_bo_chi_ge);
    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 vec_scalar_bo_chi_ge);
    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 0,
	 vec_iter_bo_chi_ge);

    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 scalar_vec_bo_chi_ge);
    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 scalar_scalar_bo_chi_ge);
    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 0,
	 scalar_iter_bo_chi_ge);

    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->add_operation
	(0,
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 iter_vec_bo_chi_ge);
    IA_Image_IP_IA_Bit_float_float_chi_ge_tbl->add_operation
	(0,
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 iter_scalar_bo_chi_ge);

}
#endif // BOT_IA_Bit_float_float_chi_ge

//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// filename FIO-X_gt.c
//
