// Emacs -*- C++ -*-

// Machine generated include file, do not modify.


// 	Copyright 1993, Center for Computer Vision and Visualization,
// 	University of Florida.  All rights reserved.


//  $Log: float-operations.desc,v $
//  Revision 1.11.1.2  1995/01/31  16:02:40  thoth
//  Need to replace the upward conversions with something...

//  Revision 1.11.1.1  1994/12/28  18:05:25  thoth
//  image operations are now friendly with FBI.
//  image ops now use operations table
//  new sgn() function.

//  Revision 1.11  1994/12/19  19:58:48  ljr
//  DOS-inspired name rework.

//  Revision 1.10  1994/10/14  20:43:19  thoth
//  The inline is much more useful in the header file.

//  Revision 1.9  1994/09/16  14:59:10  thoth
//  add fabs(image)

//  Revision 1.8  1994/07/08  16:14:11  thoth
//  fixed problems caused by returning floats instead of doubles.

//  Revision 1.7  1994/05/17  12:54:56  thoth
//  Improved operations generation scheme.  Lines from the op.desc file can
//  be quoted into the .c file to allow inclusion of infrastructure.  Also
//  the op.desc output can be redirected to several files.  The prefix
//  directive allows common information (include files) to be included in
//  every generated source file.

//  Float operations for the Float Discrete Image
#include "FloatDI.h"
#include "VectorI.h"
#include "ConstI.h"
#include "ImageIter.h"
#include "FBI.h"
#include "../valueset/OpTable.h"
//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// binary pointwise non-commutative operator/ I(float) I(float) I(float)
//
#ifndef BOT_float_float_float_operatorIAOPdv
#define BOT_float_float_float_operatorIAOPdv
IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, float>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >
	*IA_Image_IP_float_float_float_operatorIAOPdv_tbl;

void IA_fill_Image_IP_float_float_float_operatorIAOPdv_tbl();

#endif // BOT_float_float_float_operatorIAOPdv
IA_Image<IA_Point<int>, float>
operator/ ( const IA_Image<IA_Point<int>, float> &lhs,
		const IA_Image<IA_Point<int>, float> &rhs)
{
    if (lhs.domain() != rhs.domain()) {
	 IA_Image<IA_Point<int>, float>	rval;
	ia_throw(Image_DomainMismatch_Exception(__FILE__,__LINE__));
	return rval;
    }

    if (!IA_Image_IP_float_float_float_operatorIAOPdv_tbl)
	IA_fill_Image_IP_float_float_float_operatorIAOPdv_tbl();

    IA_BaseImage<IA_Point<int>, float>*(*f)( IA_BaseImage<IA_Point<int>, float> &,
		IA_BaseImage<IA_Point<int>, float> &);
    f = IA_Image_IP_float_float_float_operatorIAOPdv_tbl->lookup_operation
	(lhs.type(), rhs.type());
    IA_BaseImage<IA_Point<int>,float>	&basel = *IA_FBI<IA_Point<int>,IA_Point<int>, float,float,float>
	    ::extract_baseptr(lhs);
    IA_BaseImage<IA_Point<int>,float>	&baser = *IA_FBI<IA_Point<int>,IA_Point<int>, float,float,float>
	    ::extract_baseptr(rhs);
    return IA_Image<IA_Point<int>,float>
	(IA_FBI<IA_Point<int>,IA_Point<int>, float,float,float>
	 ::make_Image(	 f(basel,baser)));
}

//
//
//

static IA_BaseImage<IA_Point<int>, float> *
vec_vec_bo_operatorIAOPdv(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	IA_VectorI<IA_Point<int>, float> *lhs
		= (IA_VectorI<IA_Point<int>, float> *)&lhs_;
	const float *ls = lhs->vec;
	IA_VectorI<IA_Point<int>, float> *rhs
		= (IA_VectorI<IA_Point<int>, float> *)&rhs_;
	const float *rs = rhs->vec;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = ( (*ls) / (*rs) );
	    ls++;
	    rs++;
	}
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}

#ifndef vec_scalar_float_float_float_operatorIAOPdv
#define vec_scalar_float_float_float_operatorIAOPdv
static IA_BaseImage<IA_Point<int>, float> *
vec_scalar_bo_operatorIAOPdv(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	IA_VectorI<IA_Point<int>, float> *lhs
		= (IA_VectorI<IA_Point<int>, float> *)&lhs_;
	const float *ls = lhs->vec;
	IA_ConstI<IA_Point<int>, float> *rhs
		= (IA_ConstI<IA_Point<int>, float> *)&rhs_;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = ( (*ls) / (rhs->value) );
	    ls++;
	}
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}
#endif // vec_scalar_float_float_float_operatorIAOPdv

static IA_BaseImage<IA_Point<int>, float> *
vec_iter_bo_operatorIAOPdv(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	IA_VectorI<IA_Point<int>, float> *lhs
		= (IA_VectorI<IA_Point<int>, float> *)&lhs_;
	const float *ls = lhs->vec;
	float rtmp;
	IA_BaseIVIter<IA_Point<int>, float>	*riter = rhs_.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    riter->next(rtmp);
	    *(ds++) = ( (*ls) / (rtmp) );
	    ls++;
	}
	delete riter;
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}

#ifndef scalar_vec_float_float_float_operatorIAOPdv
#define scalar_vec_float_float_float_operatorIAOPdv
static IA_BaseImage<IA_Point<int>, float> *
scalar_vec_bo_operatorIAOPdv(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	IA_ConstI<IA_Point<int>, float> *lhs
		= (IA_ConstI<IA_Point<int>, float> *)&lhs_;
	IA_VectorI<IA_Point<int>, float> *rhs
		= (IA_VectorI<IA_Point<int>, float> *)&rhs_;
	const float *rs = rhs->vec;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = ( (lhs->value) / (*rs) );
	    rs++;
	}
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}
#endif // scalar_vec_float_float_float_operatorIAOPdv

#ifndef scalar_scalar_float_float_float_operatorIAOPdv
#define scalar_scalar_float_float_float_operatorIAOPdv
static IA_BaseImage<IA_Point<int>, float> *
scalar_scalar_bo_operatorIAOPdv(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
	IA_ConstI<IA_Point<int>, float> *lhs
		= (IA_ConstI<IA_Point<int>, float> *)&lhs_;
	IA_ConstI<IA_Point<int>, float> *rhs
		= (IA_ConstI<IA_Point<int>, float> *)&rhs_;
    float	aval = ( lhs->value / rhs->value );
    return new IA_ConstI<IA_Point<int>, float>(domain, aval);
}
#endif // scalar_scalar_float_float_float_operatorIAOPdv

#ifndef scalar_iter_float_float_float_operatorIAOPdv
#define scalar_iter_float_float_float_operatorIAOPdv
static IA_BaseImage<IA_Point<int>, float> *
scalar_iter_bo_operatorIAOPdv(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	IA_ConstI<IA_Point<int>, float> *lhs
		= (IA_ConstI<IA_Point<int>, float> *)&lhs_;
	float rtmp;
	IA_BaseIVIter<IA_Point<int>, float>	*riter = rhs_.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    riter->next(rtmp);
	    *(ds++) = ( (lhs->value) / (rtmp) );
	}
	delete riter;
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}
#endif // scalar_iter_float_float_float_operatorIAOPdv

static IA_BaseImage<IA_Point<int>, float> *
iter_vec_bo_operatorIAOPdv(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	float ltmp;
	IA_BaseIVIter<IA_Point<int>, float>	*liter = lhs_.value_iterator();
	IA_VectorI<IA_Point<int>, float> *rhs
		= (IA_VectorI<IA_Point<int>, float> *)&rhs_;
	const float *rs = rhs->vec;
	for (unsigned i=0; i<sz; i++) {
	    liter->next(ltmp);
	    *(ds++) = ( (ltmp) / (*rs) );
	    rs++;
	}
	delete liter;
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}

#ifndef iter_scalar_float_float_float_operatorIAOPdv
#define iter_scalar_float_float_float_operatorIAOPdv
static IA_BaseImage<IA_Point<int>, float> *
iter_scalar_bo_operatorIAOPdv(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	float ltmp;
	IA_BaseIVIter<IA_Point<int>, float>	*liter = lhs_.value_iterator();
	IA_ConstI<IA_Point<int>, float> *rhs
		= (IA_ConstI<IA_Point<int>, float> *)&rhs_;
	for (unsigned i=0; i<sz; i++) {
	    liter->next(ltmp);
	    *(ds++) = ( (ltmp) / (rhs->value) );
	}
	delete liter;
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}
#endif // iter_scalar_float_float_float_operatorIAOPdv

static IA_BaseImage<IA_Point<int>, float> *
iter_iter_bo_operatorIAOPdv(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	float ltmp;
	IA_BaseIVIter<IA_Point<int>, float>	*liter = lhs_.value_iterator();
	float rtmp;
	IA_BaseIVIter<IA_Point<int>, float>	*riter = rhs_.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    liter->next(ltmp);
	    riter->next(rtmp);
	    *(ds++) = ( (ltmp) / (rtmp) );
	}
	delete liter;
	delete riter;
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}

#ifndef FILL_BOT_float_float_float_operatorIAOPdv
#define FILL_BOT_float_float_float_operatorIAOPdv
void IA_fill_Image_IP_float_float_float_operatorIAOPdv_tbl()
{
    if (IA_Image_IP_float_float_float_operatorIAOPdv_tbl)
	return;

    IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, float>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >::function f;
    f = iter_iter_bo_operatorIAOPdv;

    IA_Image_IP_float_float_float_operatorIAOPdv_tbl = new IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, float>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >(iter_iter_bo_operatorIAOPdv);
    IA_Image_IP_float_float_float_operatorIAOPdv_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 vec_vec_bo_operatorIAOPdv);
    IA_Image_IP_float_float_float_operatorIAOPdv_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 vec_scalar_bo_operatorIAOPdv);
    IA_Image_IP_float_float_float_operatorIAOPdv_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 0,
	 vec_iter_bo_operatorIAOPdv);

    IA_Image_IP_float_float_float_operatorIAOPdv_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 scalar_vec_bo_operatorIAOPdv);
    IA_Image_IP_float_float_float_operatorIAOPdv_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 scalar_scalar_bo_operatorIAOPdv);
    IA_Image_IP_float_float_float_operatorIAOPdv_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 0,
	 scalar_iter_bo_operatorIAOPdv);

    IA_Image_IP_float_float_float_operatorIAOPdv_tbl->add_operation
	(0,
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 iter_vec_bo_operatorIAOPdv);
    IA_Image_IP_float_float_float_operatorIAOPdv_tbl->add_operation
	(0,
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 iter_scalar_bo_operatorIAOPdv);

}
#endif // BOT_float_float_float_operatorIAOPdv

//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// binary pointwise non-commutative operator/ I(float) I(float) float
//
#ifndef BOT_float_float_float_operatorIAOPdv
#define BOT_float_float_float_operatorIAOPdv
IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, float>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >
	*IA_Image_IP_float_float_float_operatorIAOPdv_tbl;

void IA_fill_Image_IP_float_float_float_operatorIAOPdv_tbl();

#endif // BOT_float_float_float_operatorIAOPdv
IA_Image<IA_Point<int>, float>
operator/ ( const IA_Image<IA_Point<int>, float> &lhs,
		float rhs)
{
    if (!IA_Image_IP_float_float_float_operatorIAOPdv_tbl)
	IA_fill_Image_IP_float_float_float_operatorIAOPdv_tbl();

    IA_BaseImage<IA_Point<int>, float>*(*f)( IA_BaseImage<IA_Point<int>, float> &,
		IA_BaseImage<IA_Point<int>, float> &);
    f = IA_Image_IP_float_float_float_operatorIAOPdv_tbl->lookup_operation
	(lhs.type(), IA_ConstI<IA_Point<int>, float>::s_type());
    IA_BaseImage<IA_Point<int>,float>	&basel = *IA_FBI<IA_Point<int>,IA_Point<int>, float,float,float>
	    ::extract_baseptr(lhs);
    IA_ConstI<IA_Point<int>,float>	baser(lhs.domain(), rhs);
    return IA_Image<IA_Point<int>,float>
	(IA_FBI<IA_Point<int>,IA_Point<int>, float,float,float>
	 ::make_Image(	 f(basel,baser)));
}

//
//
//

#ifndef vec_scalar_float_float_float_operatorIAOPdv
#define vec_scalar_float_float_float_operatorIAOPdv
static IA_BaseImage<IA_Point<int>, float> *
vec_scalar_bo_operatorIAOPdv(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	IA_VectorI<IA_Point<int>, float> *lhs
		= (IA_VectorI<IA_Point<int>, float> *)&lhs_;
	const float *ls = lhs->vec;
	IA_ConstI<IA_Point<int>, float> *rhs
		= (IA_ConstI<IA_Point<int>, float> *)&rhs_;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = ( (*ls) / (rhs->value) );
	    ls++;
	}
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}
#endif // vec_scalar_float_float_float_operatorIAOPdv

#ifndef scalar_scalar_float_float_float_operatorIAOPdv
#define scalar_scalar_float_float_float_operatorIAOPdv
static IA_BaseImage<IA_Point<int>, float> *
scalar_scalar_bo_operatorIAOPdv(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
	IA_ConstI<IA_Point<int>, float> *lhs
		= (IA_ConstI<IA_Point<int>, float> *)&lhs_;
	IA_ConstI<IA_Point<int>, float> *rhs
		= (IA_ConstI<IA_Point<int>, float> *)&rhs_;
    float	aval = ( lhs->value / rhs->value );
    return new IA_ConstI<IA_Point<int>, float>(domain, aval);
}
#endif // scalar_scalar_float_float_float_operatorIAOPdv

#ifndef iter_scalar_float_float_float_operatorIAOPdv
#define iter_scalar_float_float_float_operatorIAOPdv
static IA_BaseImage<IA_Point<int>, float> *
iter_scalar_bo_operatorIAOPdv(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	float ltmp;
	IA_BaseIVIter<IA_Point<int>, float>	*liter = lhs_.value_iterator();
	IA_ConstI<IA_Point<int>, float> *rhs
		= (IA_ConstI<IA_Point<int>, float> *)&rhs_;
	for (unsigned i=0; i<sz; i++) {
	    liter->next(ltmp);
	    *(ds++) = ( (ltmp) / (rhs->value) );
	}
	delete liter;
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}
#endif // iter_scalar_float_float_float_operatorIAOPdv

#ifndef FILL_BOT_float_float_float_operatorIAOPdv
#define FILL_BOT_float_float_float_operatorIAOPdv
void IA_fill_Image_IP_float_float_float_operatorIAOPdv_tbl()
{
    if (IA_Image_IP_float_float_float_operatorIAOPdv_tbl)
	return;

    IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, float>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >::function f;
    f = iter_iter_bo_operatorIAOPdv;

    IA_Image_IP_float_float_float_operatorIAOPdv_tbl = new IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, float>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >(iter_iter_bo_operatorIAOPdv);
    IA_Image_IP_float_float_float_operatorIAOPdv_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 vec_vec_bo_operatorIAOPdv);
    IA_Image_IP_float_float_float_operatorIAOPdv_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 vec_scalar_bo_operatorIAOPdv);
    IA_Image_IP_float_float_float_operatorIAOPdv_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 0,
	 vec_iter_bo_operatorIAOPdv);

    IA_Image_IP_float_float_float_operatorIAOPdv_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 scalar_vec_bo_operatorIAOPdv);
    IA_Image_IP_float_float_float_operatorIAOPdv_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 scalar_scalar_bo_operatorIAOPdv);
    IA_Image_IP_float_float_float_operatorIAOPdv_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 0,
	 scalar_iter_bo_operatorIAOPdv);

    IA_Image_IP_float_float_float_operatorIAOPdv_tbl->add_operation
	(0,
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 iter_vec_bo_operatorIAOPdv);
    IA_Image_IP_float_float_float_operatorIAOPdv_tbl->add_operation
	(0,
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 iter_scalar_bo_operatorIAOPdv);

}
#endif // BOT_float_float_float_operatorIAOPdv

//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// binary pointwise non-commutative operator/ I(float) float I(float)
//
#ifndef BOT_float_float_float_operatorIAOPdv
#define BOT_float_float_float_operatorIAOPdv
IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, float>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >
	*IA_Image_IP_float_float_float_operatorIAOPdv_tbl;

void IA_fill_Image_IP_float_float_float_operatorIAOPdv_tbl();

#endif // BOT_float_float_float_operatorIAOPdv
IA_Image<IA_Point<int>, float>
operator/ ( float lhs,
		const IA_Image<IA_Point<int>, float> &rhs)
{
    if (!IA_Image_IP_float_float_float_operatorIAOPdv_tbl)
	IA_fill_Image_IP_float_float_float_operatorIAOPdv_tbl();

    IA_BaseImage<IA_Point<int>, float>*(*f)( IA_BaseImage<IA_Point<int>, float> &,
		IA_BaseImage<IA_Point<int>, float> &);
    f = IA_Image_IP_float_float_float_operatorIAOPdv_tbl->lookup_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(), rhs.type());
    IA_ConstI<IA_Point<int>,float>	basel(rhs.domain(), lhs);
    IA_BaseImage<IA_Point<int>,float>	&baser = *IA_FBI<IA_Point<int>,IA_Point<int>, float,float,float>
	    ::extract_baseptr(rhs);
    return IA_Image<IA_Point<int>,float>
	(IA_FBI<IA_Point<int>,IA_Point<int>, float,float,float>
	 ::make_Image(	 f(basel,baser)));
}

//
//
//

#ifndef scalar_vec_float_float_float_operatorIAOPdv
#define scalar_vec_float_float_float_operatorIAOPdv
static IA_BaseImage<IA_Point<int>, float> *
scalar_vec_bo_operatorIAOPdv(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	IA_ConstI<IA_Point<int>, float> *lhs
		= (IA_ConstI<IA_Point<int>, float> *)&lhs_;
	IA_VectorI<IA_Point<int>, float> *rhs
		= (IA_VectorI<IA_Point<int>, float> *)&rhs_;
	const float *rs = rhs->vec;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = ( (lhs->value) / (*rs) );
	    rs++;
	}
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}
#endif // scalar_vec_float_float_float_operatorIAOPdv

#ifndef scalar_scalar_float_float_float_operatorIAOPdv
#define scalar_scalar_float_float_float_operatorIAOPdv
static IA_BaseImage<IA_Point<int>, float> *
scalar_scalar_bo_operatorIAOPdv(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
	IA_ConstI<IA_Point<int>, float> *lhs
		= (IA_ConstI<IA_Point<int>, float> *)&lhs_;
	IA_ConstI<IA_Point<int>, float> *rhs
		= (IA_ConstI<IA_Point<int>, float> *)&rhs_;
    float	aval = ( lhs->value / rhs->value );
    return new IA_ConstI<IA_Point<int>, float>(domain, aval);
}
#endif // scalar_scalar_float_float_float_operatorIAOPdv

#ifndef scalar_iter_float_float_float_operatorIAOPdv
#define scalar_iter_float_float_float_operatorIAOPdv
static IA_BaseImage<IA_Point<int>, float> *
scalar_iter_bo_operatorIAOPdv(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	IA_ConstI<IA_Point<int>, float> *lhs
		= (IA_ConstI<IA_Point<int>, float> *)&lhs_;
	float rtmp;
	IA_BaseIVIter<IA_Point<int>, float>	*riter = rhs_.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    riter->next(rtmp);
	    *(ds++) = ( (lhs->value) / (rtmp) );
	}
	delete riter;
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}
#endif // scalar_iter_float_float_float_operatorIAOPdv

#ifndef FILL_BOT_float_float_float_operatorIAOPdv
#define FILL_BOT_float_float_float_operatorIAOPdv
void IA_fill_Image_IP_float_float_float_operatorIAOPdv_tbl()
{
    if (IA_Image_IP_float_float_float_operatorIAOPdv_tbl)
	return;

    IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, float>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >::function f;
    f = iter_iter_bo_operatorIAOPdv;

    IA_Image_IP_float_float_float_operatorIAOPdv_tbl = new IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, float>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >(iter_iter_bo_operatorIAOPdv);
    IA_Image_IP_float_float_float_operatorIAOPdv_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 vec_vec_bo_operatorIAOPdv);
    IA_Image_IP_float_float_float_operatorIAOPdv_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 vec_scalar_bo_operatorIAOPdv);
    IA_Image_IP_float_float_float_operatorIAOPdv_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 0,
	 vec_iter_bo_operatorIAOPdv);

    IA_Image_IP_float_float_float_operatorIAOPdv_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 scalar_vec_bo_operatorIAOPdv);
    IA_Image_IP_float_float_float_operatorIAOPdv_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 scalar_scalar_bo_operatorIAOPdv);
    IA_Image_IP_float_float_float_operatorIAOPdv_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 0,
	 scalar_iter_bo_operatorIAOPdv);

    IA_Image_IP_float_float_float_operatorIAOPdv_tbl->add_operation
	(0,
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 iter_vec_bo_operatorIAOPdv);
    IA_Image_IP_float_float_float_operatorIAOPdv_tbl->add_operation
	(0,
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 iter_scalar_bo_operatorIAOPdv);

}
#endif // BOT_float_float_float_operatorIAOPdv

//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// pointwise operator/= I(float) I(float)
//
// There are none (it's inline)

//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// pointwise operator/= I(float) float
//
// There are none (it's inline)

inline float pseudo_div(float a, float b)
{
    return (b==0) ? 0 : (a/b);
}

inline float pseudo_inv(float b)
{
    return (b==0) ? 0 : (1/b);
}
//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// binary pointwise non-commutative pseudo_div I(float) I(float) I(float)
//
#ifndef BOT_float_float_float_pseudo_div
#define BOT_float_float_float_pseudo_div
IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, float>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >
	*IA_Image_IP_float_float_float_pseudo_div_tbl;

void IA_fill_Image_IP_float_float_float_pseudo_div_tbl();

#endif // BOT_float_float_float_pseudo_div
IA_Image<IA_Point<int>, float>
pseudo_div ( const IA_Image<IA_Point<int>, float> &lhs,
		const IA_Image<IA_Point<int>, float> &rhs)
{
    if (lhs.domain() != rhs.domain()) {
	 IA_Image<IA_Point<int>, float>	rval;
	ia_throw(Image_DomainMismatch_Exception(__FILE__,__LINE__));
	return rval;
    }

    if (!IA_Image_IP_float_float_float_pseudo_div_tbl)
	IA_fill_Image_IP_float_float_float_pseudo_div_tbl();

    IA_BaseImage<IA_Point<int>, float>*(*f)( IA_BaseImage<IA_Point<int>, float> &,
		IA_BaseImage<IA_Point<int>, float> &);
    f = IA_Image_IP_float_float_float_pseudo_div_tbl->lookup_operation
	(lhs.type(), rhs.type());
    IA_BaseImage<IA_Point<int>,float>	&basel = *IA_FBI<IA_Point<int>,IA_Point<int>, float,float,float>
	    ::extract_baseptr(lhs);
    IA_BaseImage<IA_Point<int>,float>	&baser = *IA_FBI<IA_Point<int>,IA_Point<int>, float,float,float>
	    ::extract_baseptr(rhs);
    return IA_Image<IA_Point<int>,float>
	(IA_FBI<IA_Point<int>,IA_Point<int>, float,float,float>
	 ::make_Image(	 f(basel,baser)));
}

//
//
//

static IA_BaseImage<IA_Point<int>, float> *
vec_vec_bo_pseudo_div(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	IA_VectorI<IA_Point<int>, float> *lhs
		= (IA_VectorI<IA_Point<int>, float> *)&lhs_;
	const float *ls = lhs->vec;
	IA_VectorI<IA_Point<int>, float> *rhs
		= (IA_VectorI<IA_Point<int>, float> *)&rhs_;
	const float *rs = rhs->vec;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = pseudo_div(*ls, *rs);
	    ls++;
	    rs++;
	}
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}

#ifndef vec_scalar_float_float_float_pseudo_div
#define vec_scalar_float_float_float_pseudo_div
static IA_BaseImage<IA_Point<int>, float> *
vec_scalar_bo_pseudo_div(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	IA_VectorI<IA_Point<int>, float> *lhs
		= (IA_VectorI<IA_Point<int>, float> *)&lhs_;
	const float *ls = lhs->vec;
	IA_ConstI<IA_Point<int>, float> *rhs
		= (IA_ConstI<IA_Point<int>, float> *)&rhs_;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = pseudo_div(*ls, rhs->value);
	    ls++;
	}
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}
#endif // vec_scalar_float_float_float_pseudo_div

static IA_BaseImage<IA_Point<int>, float> *
vec_iter_bo_pseudo_div(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	IA_VectorI<IA_Point<int>, float> *lhs
		= (IA_VectorI<IA_Point<int>, float> *)&lhs_;
	const float *ls = lhs->vec;
	float rtmp;
	IA_BaseIVIter<IA_Point<int>, float>	*riter = rhs_.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    riter->next(rtmp);
	    *(ds++) = pseudo_div(*ls, rtmp);
	    ls++;
	}
	delete riter;
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}

#ifndef scalar_vec_float_float_float_pseudo_div
#define scalar_vec_float_float_float_pseudo_div
static IA_BaseImage<IA_Point<int>, float> *
scalar_vec_bo_pseudo_div(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	IA_ConstI<IA_Point<int>, float> *lhs
		= (IA_ConstI<IA_Point<int>, float> *)&lhs_;
	IA_VectorI<IA_Point<int>, float> *rhs
		= (IA_VectorI<IA_Point<int>, float> *)&rhs_;
	const float *rs = rhs->vec;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = pseudo_div(lhs->value, *rs);
	    rs++;
	}
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}
#endif // scalar_vec_float_float_float_pseudo_div

#ifndef scalar_scalar_float_float_float_pseudo_div
#define scalar_scalar_float_float_float_pseudo_div
static IA_BaseImage<IA_Point<int>, float> *
scalar_scalar_bo_pseudo_div(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
	IA_ConstI<IA_Point<int>, float> *lhs
		= (IA_ConstI<IA_Point<int>, float> *)&lhs_;
	IA_ConstI<IA_Point<int>, float> *rhs
		= (IA_ConstI<IA_Point<int>, float> *)&rhs_;
    float	aval = pseudo_div( lhs->value, rhs->value );
    return new IA_ConstI<IA_Point<int>, float>(domain, aval);
}
#endif // scalar_scalar_float_float_float_pseudo_div

#ifndef scalar_iter_float_float_float_pseudo_div
#define scalar_iter_float_float_float_pseudo_div
static IA_BaseImage<IA_Point<int>, float> *
scalar_iter_bo_pseudo_div(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	IA_ConstI<IA_Point<int>, float> *lhs
		= (IA_ConstI<IA_Point<int>, float> *)&lhs_;
	float rtmp;
	IA_BaseIVIter<IA_Point<int>, float>	*riter = rhs_.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    riter->next(rtmp);
	    *(ds++) = pseudo_div(lhs->value, rtmp);
	}
	delete riter;
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}
#endif // scalar_iter_float_float_float_pseudo_div

static IA_BaseImage<IA_Point<int>, float> *
iter_vec_bo_pseudo_div(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	float ltmp;
	IA_BaseIVIter<IA_Point<int>, float>	*liter = lhs_.value_iterator();
	IA_VectorI<IA_Point<int>, float> *rhs
		= (IA_VectorI<IA_Point<int>, float> *)&rhs_;
	const float *rs = rhs->vec;
	for (unsigned i=0; i<sz; i++) {
	    liter->next(ltmp);
	    *(ds++) = pseudo_div(ltmp, *rs);
	    rs++;
	}
	delete liter;
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}

#ifndef iter_scalar_float_float_float_pseudo_div
#define iter_scalar_float_float_float_pseudo_div
static IA_BaseImage<IA_Point<int>, float> *
iter_scalar_bo_pseudo_div(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	float ltmp;
	IA_BaseIVIter<IA_Point<int>, float>	*liter = lhs_.value_iterator();
	IA_ConstI<IA_Point<int>, float> *rhs
		= (IA_ConstI<IA_Point<int>, float> *)&rhs_;
	for (unsigned i=0; i<sz; i++) {
	    liter->next(ltmp);
	    *(ds++) = pseudo_div(ltmp, rhs->value);
	}
	delete liter;
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}
#endif // iter_scalar_float_float_float_pseudo_div

static IA_BaseImage<IA_Point<int>, float> *
iter_iter_bo_pseudo_div(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	float ltmp;
	IA_BaseIVIter<IA_Point<int>, float>	*liter = lhs_.value_iterator();
	float rtmp;
	IA_BaseIVIter<IA_Point<int>, float>	*riter = rhs_.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    liter->next(ltmp);
	    riter->next(rtmp);
	    *(ds++) = pseudo_div(ltmp, rtmp);
	}
	delete liter;
	delete riter;
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}

#ifndef FILL_BOT_float_float_float_pseudo_div
#define FILL_BOT_float_float_float_pseudo_div
void IA_fill_Image_IP_float_float_float_pseudo_div_tbl()
{
    if (IA_Image_IP_float_float_float_pseudo_div_tbl)
	return;

    IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, float>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >::function f;
    f = iter_iter_bo_pseudo_div;

    IA_Image_IP_float_float_float_pseudo_div_tbl = new IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, float>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >(iter_iter_bo_pseudo_div);
    IA_Image_IP_float_float_float_pseudo_div_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 vec_vec_bo_pseudo_div);
    IA_Image_IP_float_float_float_pseudo_div_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 vec_scalar_bo_pseudo_div);
    IA_Image_IP_float_float_float_pseudo_div_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 0,
	 vec_iter_bo_pseudo_div);

    IA_Image_IP_float_float_float_pseudo_div_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 scalar_vec_bo_pseudo_div);
    IA_Image_IP_float_float_float_pseudo_div_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 scalar_scalar_bo_pseudo_div);
    IA_Image_IP_float_float_float_pseudo_div_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 0,
	 scalar_iter_bo_pseudo_div);

    IA_Image_IP_float_float_float_pseudo_div_tbl->add_operation
	(0,
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 iter_vec_bo_pseudo_div);
    IA_Image_IP_float_float_float_pseudo_div_tbl->add_operation
	(0,
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 iter_scalar_bo_pseudo_div);

}
#endif // BOT_float_float_float_pseudo_div

//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// binary pointwise non-commutative pseudo_div I(float) I(float) float
//
#ifndef BOT_float_float_float_pseudo_div
#define BOT_float_float_float_pseudo_div
IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, float>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >
	*IA_Image_IP_float_float_float_pseudo_div_tbl;

void IA_fill_Image_IP_float_float_float_pseudo_div_tbl();

#endif // BOT_float_float_float_pseudo_div
IA_Image<IA_Point<int>, float>
pseudo_div ( const IA_Image<IA_Point<int>, float> &lhs,
		float rhs)
{
    if (!IA_Image_IP_float_float_float_pseudo_div_tbl)
	IA_fill_Image_IP_float_float_float_pseudo_div_tbl();

    IA_BaseImage<IA_Point<int>, float>*(*f)( IA_BaseImage<IA_Point<int>, float> &,
		IA_BaseImage<IA_Point<int>, float> &);
    f = IA_Image_IP_float_float_float_pseudo_div_tbl->lookup_operation
	(lhs.type(), IA_ConstI<IA_Point<int>, float>::s_type());
    IA_BaseImage<IA_Point<int>,float>	&basel = *IA_FBI<IA_Point<int>,IA_Point<int>, float,float,float>
	    ::extract_baseptr(lhs);
    IA_ConstI<IA_Point<int>,float>	baser(lhs.domain(), rhs);
    return IA_Image<IA_Point<int>,float>
	(IA_FBI<IA_Point<int>,IA_Point<int>, float,float,float>
	 ::make_Image(	 f(basel,baser)));
}

//
//
//

#ifndef vec_scalar_float_float_float_pseudo_div
#define vec_scalar_float_float_float_pseudo_div
static IA_BaseImage<IA_Point<int>, float> *
vec_scalar_bo_pseudo_div(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	IA_VectorI<IA_Point<int>, float> *lhs
		= (IA_VectorI<IA_Point<int>, float> *)&lhs_;
	const float *ls = lhs->vec;
	IA_ConstI<IA_Point<int>, float> *rhs
		= (IA_ConstI<IA_Point<int>, float> *)&rhs_;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = pseudo_div(*ls, rhs->value);
	    ls++;
	}
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}
#endif // vec_scalar_float_float_float_pseudo_div

#ifndef scalar_scalar_float_float_float_pseudo_div
#define scalar_scalar_float_float_float_pseudo_div
static IA_BaseImage<IA_Point<int>, float> *
scalar_scalar_bo_pseudo_div(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
	IA_ConstI<IA_Point<int>, float> *lhs
		= (IA_ConstI<IA_Point<int>, float> *)&lhs_;
	IA_ConstI<IA_Point<int>, float> *rhs
		= (IA_ConstI<IA_Point<int>, float> *)&rhs_;
    float	aval = pseudo_div( lhs->value, rhs->value );
    return new IA_ConstI<IA_Point<int>, float>(domain, aval);
}
#endif // scalar_scalar_float_float_float_pseudo_div

#ifndef iter_scalar_float_float_float_pseudo_div
#define iter_scalar_float_float_float_pseudo_div
static IA_BaseImage<IA_Point<int>, float> *
iter_scalar_bo_pseudo_div(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	float ltmp;
	IA_BaseIVIter<IA_Point<int>, float>	*liter = lhs_.value_iterator();
	IA_ConstI<IA_Point<int>, float> *rhs
		= (IA_ConstI<IA_Point<int>, float> *)&rhs_;
	for (unsigned i=0; i<sz; i++) {
	    liter->next(ltmp);
	    *(ds++) = pseudo_div(ltmp, rhs->value);
	}
	delete liter;
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}
#endif // iter_scalar_float_float_float_pseudo_div

#ifndef FILL_BOT_float_float_float_pseudo_div
#define FILL_BOT_float_float_float_pseudo_div
void IA_fill_Image_IP_float_float_float_pseudo_div_tbl()
{
    if (IA_Image_IP_float_float_float_pseudo_div_tbl)
	return;

    IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, float>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >::function f;
    f = iter_iter_bo_pseudo_div;

    IA_Image_IP_float_float_float_pseudo_div_tbl = new IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, float>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >(iter_iter_bo_pseudo_div);
    IA_Image_IP_float_float_float_pseudo_div_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 vec_vec_bo_pseudo_div);
    IA_Image_IP_float_float_float_pseudo_div_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 vec_scalar_bo_pseudo_div);
    IA_Image_IP_float_float_float_pseudo_div_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 0,
	 vec_iter_bo_pseudo_div);

    IA_Image_IP_float_float_float_pseudo_div_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 scalar_vec_bo_pseudo_div);
    IA_Image_IP_float_float_float_pseudo_div_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 scalar_scalar_bo_pseudo_div);
    IA_Image_IP_float_float_float_pseudo_div_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 0,
	 scalar_iter_bo_pseudo_div);

    IA_Image_IP_float_float_float_pseudo_div_tbl->add_operation
	(0,
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 iter_vec_bo_pseudo_div);
    IA_Image_IP_float_float_float_pseudo_div_tbl->add_operation
	(0,
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 iter_scalar_bo_pseudo_div);

}
#endif // BOT_float_float_float_pseudo_div

//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// binary pointwise non-commutative pseudo_div I(float) float I(float)
//
#ifndef BOT_float_float_float_pseudo_div
#define BOT_float_float_float_pseudo_div
IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, float>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >
	*IA_Image_IP_float_float_float_pseudo_div_tbl;

void IA_fill_Image_IP_float_float_float_pseudo_div_tbl();

#endif // BOT_float_float_float_pseudo_div
IA_Image<IA_Point<int>, float>
pseudo_div ( float lhs,
		const IA_Image<IA_Point<int>, float> &rhs)
{
    if (!IA_Image_IP_float_float_float_pseudo_div_tbl)
	IA_fill_Image_IP_float_float_float_pseudo_div_tbl();

    IA_BaseImage<IA_Point<int>, float>*(*f)( IA_BaseImage<IA_Point<int>, float> &,
		IA_BaseImage<IA_Point<int>, float> &);
    f = IA_Image_IP_float_float_float_pseudo_div_tbl->lookup_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(), rhs.type());
    IA_ConstI<IA_Point<int>,float>	basel(rhs.domain(), lhs);
    IA_BaseImage<IA_Point<int>,float>	&baser = *IA_FBI<IA_Point<int>,IA_Point<int>, float,float,float>
	    ::extract_baseptr(rhs);
    return IA_Image<IA_Point<int>,float>
	(IA_FBI<IA_Point<int>,IA_Point<int>, float,float,float>
	 ::make_Image(	 f(basel,baser)));
}

//
//
//

#ifndef scalar_vec_float_float_float_pseudo_div
#define scalar_vec_float_float_float_pseudo_div
static IA_BaseImage<IA_Point<int>, float> *
scalar_vec_bo_pseudo_div(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	IA_ConstI<IA_Point<int>, float> *lhs
		= (IA_ConstI<IA_Point<int>, float> *)&lhs_;
	IA_VectorI<IA_Point<int>, float> *rhs
		= (IA_VectorI<IA_Point<int>, float> *)&rhs_;
	const float *rs = rhs->vec;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = pseudo_div(lhs->value, *rs);
	    rs++;
	}
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}
#endif // scalar_vec_float_float_float_pseudo_div

#ifndef scalar_scalar_float_float_float_pseudo_div
#define scalar_scalar_float_float_float_pseudo_div
static IA_BaseImage<IA_Point<int>, float> *
scalar_scalar_bo_pseudo_div(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
	IA_ConstI<IA_Point<int>, float> *lhs
		= (IA_ConstI<IA_Point<int>, float> *)&lhs_;
	IA_ConstI<IA_Point<int>, float> *rhs
		= (IA_ConstI<IA_Point<int>, float> *)&rhs_;
    float	aval = pseudo_div( lhs->value, rhs->value );
    return new IA_ConstI<IA_Point<int>, float>(domain, aval);
}
#endif // scalar_scalar_float_float_float_pseudo_div

#ifndef scalar_iter_float_float_float_pseudo_div
#define scalar_iter_float_float_float_pseudo_div
static IA_BaseImage<IA_Point<int>, float> *
scalar_iter_bo_pseudo_div(IA_BaseImage<IA_Point<int>, float> &lhs_,
	IA_BaseImage<IA_Point<int>, float> &rhs_)
{
    const IA_Set<IA_Point<int> > domain = lhs_.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	IA_ConstI<IA_Point<int>, float> *lhs
		= (IA_ConstI<IA_Point<int>, float> *)&lhs_;
	float rtmp;
	IA_BaseIVIter<IA_Point<int>, float>	*riter = rhs_.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    riter->next(rtmp);
	    *(ds++) = pseudo_div(lhs->value, rtmp);
	}
	delete riter;
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}
#endif // scalar_iter_float_float_float_pseudo_div

#ifndef FILL_BOT_float_float_float_pseudo_div
#define FILL_BOT_float_float_float_pseudo_div
void IA_fill_Image_IP_float_float_float_pseudo_div_tbl()
{
    if (IA_Image_IP_float_float_float_pseudo_div_tbl)
	return;

    IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, float>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >::function f;
    f = iter_iter_bo_pseudo_div;

    IA_Image_IP_float_float_float_pseudo_div_tbl = new IA_BinaryOperationsTable<IA_BaseImage<IA_Point<int>, float>*,
	IA_BaseImage<IA_Point<int>, float>,
	IA_BaseImage<IA_Point<int>, float> >(iter_iter_bo_pseudo_div);
    IA_Image_IP_float_float_float_pseudo_div_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 vec_vec_bo_pseudo_div);
    IA_Image_IP_float_float_float_pseudo_div_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 vec_scalar_bo_pseudo_div);
    IA_Image_IP_float_float_float_pseudo_div_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 0,
	 vec_iter_bo_pseudo_div);

    IA_Image_IP_float_float_float_pseudo_div_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 scalar_vec_bo_pseudo_div);
    IA_Image_IP_float_float_float_pseudo_div_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 scalar_scalar_bo_pseudo_div);
    IA_Image_IP_float_float_float_pseudo_div_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 0,
	 scalar_iter_bo_pseudo_div);

    IA_Image_IP_float_float_float_pseudo_div_tbl->add_operation
	(0,
	 IA_VectorI<IA_Point<int>, float>::s_type(),
	 iter_vec_bo_pseudo_div);
    IA_Image_IP_float_float_float_pseudo_div_tbl->add_operation
	(0,
	 IA_ConstI<IA_Point<int>, float>::s_type(),
	 iter_scalar_bo_pseudo_div);

}
#endif // BOT_float_float_float_pseudo_div

//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// unary pointwise pseudo_inv I(float) I(float)
//
// Emacs: -*- C++ -*-

//
//	Copyright 1993, Center for Computer Vision and Visualization,
//	University of Florida.  All rights reserved.
//


//
// $Log: unary-op.templ,v $
// Revision 1.4.1.2  1995/01/13  19:37:42  thoth
// CoreImage has been re-merged with Image.  All special stuff should be
// friends of FBI now.
//
// Revision 1.4.1.1  1994/12/28  17:22:11  thoth
// image operations are friends of FBI now.
//
// Revision 1.4  1994/07/25  17:26:39  thoth
// Name sanitization
//
// Revision 1.3  1994/01/07  15:15:14  thoth
// Image class is now CoreImage and named image types are
// Image<P,T>.
//
// Revision 1.2  1993/12/29  17:33:18  thoth
// New operator scheme that prevents the need for trivial Image conversions.
//
// Revision 1.1  1993/09/15  13:07:16  thoth
// Initial revision
//
// Revision 1.2  93/05/27  11:49:04  thoth
// Copyright Notices
// 
// Revision 1.1  93/03/10  13:50:00  thoth
// Initial revision
// 

#ifndef UOT_float_float_pseudo_inv
#define UOT_float_float_pseudo_inv
IA_UnaryOperationsTable<IA_BaseImage<IA_Point<int>, float>*,
	IA_BaseImage<IA_Point<int>, float> >
	*IA_Image_IP_float_float_pseudo_inv_tbl;

void IA_fill_Image_IP_float_float_pseudo_inv_tbl();
#endif


IA_Image<IA_Point<int>, float>
pseudo_inv ( const IA_Image<IA_Point<int>, float> &arg)
{
    if (!IA_Image_IP_float_float_pseudo_inv_tbl)
	IA_fill_Image_IP_float_float_pseudo_inv_tbl();

    IA_BaseImage<IA_Point<int>, float>*(*f)
	(IA_BaseImage<IA_Point<int>, float> &);
    f = IA_Image_IP_float_float_pseudo_inv_tbl->lookup_operation (arg.type());

    
    IA_BaseImage<IA_Point<int>, float>	&bip =
	*IA_FBI<IA_Point<int>,IA_Point<int>,float,float,float>
	    ::extract_baseptr(arg);

    return IA_FBI<IA_Point<int>,IA_Point<int>, float,float,float>
	 ::make_Image(f(bip));
}

#ifndef vec_uop_float_float_pseudo_inv
#define vec_uop_float_float_pseudo_inv
static IA_BaseImage<IA_Point<int>, float>*
vec_uo_pseudo_inv(IA_BaseImage<IA_Point<int>, float> &lhs_)
{
    const IA_VectorI<IA_Point<int>, float> *lhs =
	(IA_VectorI<IA_Point<int>, float> *) &lhs_;

    const IA_Set<IA_Point<int> > domain = lhs->domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	const float *ls = lhs->vec;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = pseudo_inv(*(ls++));
	}
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}
#endif // vec_uop_float_float_pseudo_inv

#ifndef scalar_uop_float_float_pseudo_inv
#define scalar_uop_float_float_pseudo_inv
static IA_BaseImage<IA_Point<int>, float>*
scalar_uo_pseudo_inv(IA_BaseImage<IA_Point<int>, float> &lhs_)
{
    const IA_ConstI<IA_Point<int>, float> *lhs =
	(IA_ConstI<IA_Point<int>, float> *) &lhs_;

    const IA_Set<IA_Point<int> > domain = lhs->domain();

    return new IA_ConstI<IA_Point<int>, float>(domain, pseudo_inv(lhs->value));
}
#endif // scalar_uop_float_float_pseudo_inv

// scalar-scalar operation is trivial

#ifndef iter_uop_float_float_pseudo_inv
#define iter_uop_float_float_pseudo_inv
static IA_BaseImage<IA_Point<int>, float>*
iter_uo_pseudo_inv(IA_BaseImage<IA_Point<int>, float> &lhs)
{
    const IA_Set<IA_Point<int> > domain = lhs.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	float ltmp;
	IA_BaseIVIter<IA_Point<int>, float>	*liter = lhs.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    liter->next(ltmp);
	    *(ds++) = pseudo_inv(ltmp);
	}
	delete liter;
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}
#endif // iter_uop_float_float_pseudo_inv

#ifndef FILL_UOT_float_float_pseudo_inv
#define FILL_UOT_float_float_pseudo_inv
void IA_fill_Image_IP_float_float_pseudo_inv_tbl()
{
    if (IA_Image_IP_float_float_pseudo_inv_tbl)
	return;

    IA_UnaryOperationsTable<IA_BaseImage<IA_Point<int>, float>*,
	IA_BaseImage<IA_Point<int>, float> >::function f;
    f = iter_uo_pseudo_inv;

    IA_Image_IP_float_float_pseudo_inv_tbl = new IA_UnaryOperationsTable<IA_BaseImage<IA_Point<int>, float>*,
	IA_BaseImage<IA_Point<int>, float> >(iter_uo_pseudo_inv);
    IA_Image_IP_float_float_pseudo_inv_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 vec_uo_pseudo_inv);
    IA_Image_IP_float_float_pseudo_inv_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 scalar_uo_pseudo_inv);

}
#endif // UOT_float_float_pseudo_inv

//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// filename FIO-__aa.c
//
