// Emacs -*- C++ -*-

// Machine generated include file, do not modify.


// 	Copyright 1993, Center for Computer Vision and Visualization,
// 	University of Florida.  All rights reserved.


//  $Log: float-operations.desc,v $
//  Revision 1.11.1.2  1995/01/31  16:02:40  thoth
//  Need to replace the upward conversions with something...

//  Revision 1.11.1.1  1994/12/28  18:05:25  thoth
//  image operations are now friendly with FBI.
//  image ops now use operations table
//  new sgn() function.

//  Revision 1.11  1994/12/19  19:58:48  ljr
//  DOS-inspired name rework.

//  Revision 1.10  1994/10/14  20:43:19  thoth
//  The inline is much more useful in the header file.

//  Revision 1.9  1994/09/16  14:59:10  thoth
//  add fabs(image)

//  Revision 1.8  1994/07/08  16:14:11  thoth
//  fixed problems caused by returning floats instead of doubles.

//  Revision 1.7  1994/05/17  12:54:56  thoth
//  Improved operations generation scheme.  Lines from the op.desc file can
//  be quoted into the .c file to allow inclusion of infrastructure.  Also
//  the op.desc output can be redirected to several files.  The prefix
//  directive allows common information (include files) to be included in
//  every generated source file.

//  Float operations for the Float Discrete Image
#include "FloatDI.h"
#include "VectorI.h"
#include "ConstI.h"
#include "ImageIter.h"
#include "FBI.h"
#include "../valueset/OpTable.h"
//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// unary pointwise operator! I(float) I(float)
//
// Emacs: -*- C++ -*-

//
//	Copyright 1993, Center for Computer Vision and Visualization,
//	University of Florida.  All rights reserved.
//


//
// $Log: unary-op.templ,v $
// Revision 1.4.1.2  1995/01/13  19:37:42  thoth
// CoreImage has been re-merged with Image.  All special stuff should be
// friends of FBI now.
//
// Revision 1.4.1.1  1994/12/28  17:22:11  thoth
// image operations are friends of FBI now.
//
// Revision 1.4  1994/07/25  17:26:39  thoth
// Name sanitization
//
// Revision 1.3  1994/01/07  15:15:14  thoth
// Image class is now CoreImage and named image types are
// Image<P,T>.
//
// Revision 1.2  1993/12/29  17:33:18  thoth
// New operator scheme that prevents the need for trivial Image conversions.
//
// Revision 1.1  1993/09/15  13:07:16  thoth
// Initial revision
//
// Revision 1.2  93/05/27  11:49:04  thoth
// Copyright Notices
// 
// Revision 1.1  93/03/10  13:50:00  thoth
// Initial revision
// 

#ifndef UOT_float_float_operatorIAOPno
#define UOT_float_float_operatorIAOPno
IA_UnaryOperationsTable<IA_BaseImage<IA_Point<int>, float>*,
	IA_BaseImage<IA_Point<int>, float> >
	*IA_Image_IP_float_float_operatorIAOPno_tbl;

void IA_fill_Image_IP_float_float_operatorIAOPno_tbl();
#endif


IA_Image<IA_Point<int>, float>
operator! ( const IA_Image<IA_Point<int>, float> &arg)
{
    if (!IA_Image_IP_float_float_operatorIAOPno_tbl)
	IA_fill_Image_IP_float_float_operatorIAOPno_tbl();

    IA_BaseImage<IA_Point<int>, float>*(*f)
	(IA_BaseImage<IA_Point<int>, float> &);
    f = IA_Image_IP_float_float_operatorIAOPno_tbl->lookup_operation (arg.type());

    
    IA_BaseImage<IA_Point<int>, float>	&bip =
	*IA_FBI<IA_Point<int>,IA_Point<int>,float,float,float>
	    ::extract_baseptr(arg);

    return IA_FBI<IA_Point<int>,IA_Point<int>, float,float,float>
	 ::make_Image(f(bip));
}

#ifndef vec_uop_float_float_operatorIAOPno
#define vec_uop_float_float_operatorIAOPno
static IA_BaseImage<IA_Point<int>, float>*
vec_uo_operatorIAOPno(IA_BaseImage<IA_Point<int>, float> &lhs_)
{
    const IA_VectorI<IA_Point<int>, float> *lhs =
	(IA_VectorI<IA_Point<int>, float> *) &lhs_;

    const IA_Set<IA_Point<int> > domain = lhs->domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	const float *ls = lhs->vec;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = !(*(ls++));
	}
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}
#endif // vec_uop_float_float_operatorIAOPno

#ifndef scalar_uop_float_float_operatorIAOPno
#define scalar_uop_float_float_operatorIAOPno
static IA_BaseImage<IA_Point<int>, float>*
scalar_uo_operatorIAOPno(IA_BaseImage<IA_Point<int>, float> &lhs_)
{
    const IA_ConstI<IA_Point<int>, float> *lhs =
	(IA_ConstI<IA_Point<int>, float> *) &lhs_;

    const IA_Set<IA_Point<int> > domain = lhs->domain();

    return new IA_ConstI<IA_Point<int>, float>(domain, !(lhs->value));
}
#endif // scalar_uop_float_float_operatorIAOPno

// scalar-scalar operation is trivial

#ifndef iter_uop_float_float_operatorIAOPno
#define iter_uop_float_float_operatorIAOPno
static IA_BaseImage<IA_Point<int>, float>*
iter_uo_operatorIAOPno(IA_BaseImage<IA_Point<int>, float> &lhs)
{
    const IA_Set<IA_Point<int> > domain = lhs.domain();
    const unsigned sz = domain.card();
    float *const vec = new float[sz];

    {
	float *ds = vec;
	float ltmp;
	IA_BaseIVIter<IA_Point<int>, float>	*liter = lhs.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    liter->next(ltmp);
	    *(ds++) = !(ltmp);
	}
	delete liter;
    }
    return new IA_VectorI<IA_Point<int>, float>(domain, vec, sz, 1);
}
#endif // iter_uop_float_float_operatorIAOPno

#ifndef FILL_UOT_float_float_operatorIAOPno
#define FILL_UOT_float_float_operatorIAOPno
void IA_fill_Image_IP_float_float_operatorIAOPno_tbl()
{
    if (IA_Image_IP_float_float_operatorIAOPno_tbl)
	return;

    IA_UnaryOperationsTable<IA_BaseImage<IA_Point<int>, float>*,
	IA_BaseImage<IA_Point<int>, float> >::function f;
    f = iter_uo_operatorIAOPno;

    IA_Image_IP_float_float_operatorIAOPno_tbl = new IA_UnaryOperationsTable<IA_BaseImage<IA_Point<int>, float>*,
	IA_BaseImage<IA_Point<int>, float> >(iter_uo_operatorIAOPno);
    IA_Image_IP_float_float_operatorIAOPno_tbl->add_operation
	(IA_VectorI<IA_Point<int>, float>::s_type(),
	 vec_uo_operatorIAOPno);
    IA_Image_IP_float_float_operatorIAOPno_tbl->add_operation
	(IA_ConstI<IA_Point<int>, float>::s_type(),
	 scalar_uo_operatorIAOPno);

}
#endif // UOT_float_float_operatorIAOPno

//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// filename FIO-__lt.c
//
