// Emacs -*- C++ -*-

// Machine generated include file, do not modify.


// 	Copyright 1993, Center for Computer Vision and Visualization,
// 	University of Florida.  All rights reserved.


//  $Log: int-operations.desc,v $
//  Revision 1.9.1.2  1995/01/31  16:02:40  thoth
//  Need to replace the upward conversions with something...

//  Revision 1.9.1.1  1994/12/28  17:56:27  thoth
//  Conversion to operations table.
//  image operations are now friendly with FBI.
//  new sgn() function.

//  Revision 1.9  1994/12/19  19:58:48  ljr
//  DOS-inspired name rework.

//  Revision 1.8  1994/05/17  12:54:56  thoth
//  Improved operations generation scheme.  Lines from the op.desc file can
//  be quoted into the .c file to allow inclusion of infrastructure.  Also
//  the op.desc output can be redirected to several files.  The prefix
//  directive allows common information (include files) to be included in
//  every generated source file.

//  Integer operations for the Int Discrete Image
#include "IntDI.h"
#include "VectorI.h"
#include "ConstI.h"
#include "ImageIter.h"
#include "FBI.h"
#include "../valueset/OpTable.h"
// conversion I(complex) I(int)
//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// unary pointwise to_complex subop= I(complex) I(int)
//
// Emacs: -*- C++ -*-

//
//	Copyright 1993, Center for Computer Vision and Visualization,
//	University of Florida.  All rights reserved.
//


//
// $Log: unary-op.templ,v $
// Revision 1.4.1.2  1995/01/13  19:37:42  thoth
// CoreImage has been re-merged with Image.  All special stuff should be
// friends of FBI now.
//
// Revision 1.4.1.1  1994/12/28  17:22:11  thoth
// image operations are friends of FBI now.
//
// Revision 1.4  1994/07/25  17:26:39  thoth
// Name sanitization
//
// Revision 1.3  1994/01/07  15:15:14  thoth
// Image class is now CoreImage and named image types are
// Image<P,T>.
//
// Revision 1.2  1993/12/29  17:33:18  thoth
// New operator scheme that prevents the need for trivial Image conversions.
//
// Revision 1.1  1993/09/15  13:07:16  thoth
// Initial revision
//
// Revision 1.2  93/05/27  11:49:04  thoth
// Copyright Notices
// 
// Revision 1.1  93/03/10  13:50:00  thoth
// Initial revision
// 

#ifndef UOT_complex_int_to_complex
#define UOT_complex_int_to_complex
IA_UnaryOperationsTable<IA_BaseImage<IA_Point<int>, complex>*,
	IA_BaseImage<IA_Point<int>, int> >
	*IA_Image_IP_complex_int_to_complex_tbl;

void IA_fill_Image_IP_complex_int_to_complex_tbl();
#endif


IA_Image<IA_Point<int>, complex>
to_complex ( const IA_Image<IA_Point<int>, int> &arg)
{
    if (!IA_Image_IP_complex_int_to_complex_tbl)
	IA_fill_Image_IP_complex_int_to_complex_tbl();

    IA_BaseImage<IA_Point<int>, complex>*(*f)
	(IA_BaseImage<IA_Point<int>, int> &);
    f = IA_Image_IP_complex_int_to_complex_tbl->lookup_operation (arg.type());

    
    IA_BaseImage<IA_Point<int>, int>	&bip =
	*IA_FBI<IA_Point<int>,IA_Point<int>,int,int,int>
	    ::extract_baseptr(arg);

    return IA_FBI<IA_Point<int>,IA_Point<int>, complex,complex,complex>
	 ::make_Image(f(bip));
}

#ifndef vec_uop_complex_int_to_complex
#define vec_uop_complex_int_to_complex
static IA_BaseImage<IA_Point<int>, complex>*
vec_uo_to_complex(IA_BaseImage<IA_Point<int>, int> &lhs_)
{
    const IA_VectorI<IA_Point<int>, int> *lhs =
	(IA_VectorI<IA_Point<int>, int> *) &lhs_;

    const IA_Set<IA_Point<int> > domain = lhs->domain();
    const unsigned sz = domain.card();
    complex *const vec = new complex[sz];

    {
	complex *ds = vec;
	const int *ls = lhs->vec;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = (*(ls++));
	}
    }
    return new IA_VectorI<IA_Point<int>, complex>(domain, vec, sz, 1);
}
#endif // vec_uop_complex_int_to_complex

#ifndef scalar_uop_complex_int_to_complex
#define scalar_uop_complex_int_to_complex
static IA_BaseImage<IA_Point<int>, complex>*
scalar_uo_to_complex(IA_BaseImage<IA_Point<int>, int> &lhs_)
{
    const IA_ConstI<IA_Point<int>, int> *lhs =
	(IA_ConstI<IA_Point<int>, int> *) &lhs_;

    const IA_Set<IA_Point<int> > domain = lhs->domain();

    return new IA_ConstI<IA_Point<int>, complex>(domain, (lhs->value));
}
#endif // scalar_uop_complex_int_to_complex

// scalar-scalar operation is trivial

#ifndef iter_uop_complex_int_to_complex
#define iter_uop_complex_int_to_complex
static IA_BaseImage<IA_Point<int>, complex>*
iter_uo_to_complex(IA_BaseImage<IA_Point<int>, int> &lhs)
{
    const IA_Set<IA_Point<int> > domain = lhs.domain();
    const unsigned sz = domain.card();
    complex *const vec = new complex[sz];

    {
	complex *ds = vec;
	int ltmp;
	IA_BaseIVIter<IA_Point<int>, int>	*liter = lhs.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    liter->next(ltmp);
	    *(ds++) = (ltmp);
	}
	delete liter;
    }
    return new IA_VectorI<IA_Point<int>, complex>(domain, vec, sz, 1);
}
#endif // iter_uop_complex_int_to_complex

#ifndef FILL_UOT_complex_int_to_complex
#define FILL_UOT_complex_int_to_complex
void IA_fill_Image_IP_complex_int_to_complex_tbl()
{
    if (IA_Image_IP_complex_int_to_complex_tbl)
	return;

    IA_UnaryOperationsTable<IA_BaseImage<IA_Point<int>, complex>*,
	IA_BaseImage<IA_Point<int>, int> >::function f;
    f = iter_uo_to_complex;

    IA_Image_IP_complex_int_to_complex_tbl = new IA_UnaryOperationsTable<IA_BaseImage<IA_Point<int>, complex>*,
	IA_BaseImage<IA_Point<int>, int> >(iter_uo_to_complex);
    IA_Image_IP_complex_int_to_complex_tbl->add_operation
	(IA_VectorI<IA_Point<int>, int>::s_type(),
	 vec_uo_to_complex);
    IA_Image_IP_complex_int_to_complex_tbl->add_operation
	(IA_ConstI<IA_Point<int>, int>::s_type(),
	 scalar_uo_to_complex);

}
#endif // UOT_complex_int_to_complex

//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// filename IIO-cvfloat.c
//
