// Emacs -*- C++ -*-

// Machine generated include file, do not modify.


// 	Copyright 1993, Center for Computer Vision and Visualization,
// 	University of Florida.  All rights reserved.


//  $Log: int-operations.desc,v $
//  Revision 1.9.1.2  1995/01/31  16:02:40  thoth
//  Need to replace the upward conversions with something...

//  Revision 1.9.1.1  1994/12/28  17:56:27  thoth
//  Conversion to operations table.
//  image operations are now friendly with FBI.
//  new sgn() function.

//  Revision 1.9  1994/12/19  19:58:48  ljr
//  DOS-inspired name rework.

//  Revision 1.8  1994/05/17  12:54:56  thoth
//  Improved operations generation scheme.  Lines from the op.desc file can
//  be quoted into the .c file to allow inclusion of infrastructure.  Also
//  the op.desc output can be redirected to several files.  The prefix
//  directive allows common information (include files) to be included in
//  every generated source file.

//  Integer operations for the Int Discrete Image
#include "IntDI.h"
#include "VectorI.h"
#include "ConstI.h"
#include "ImageIter.h"
#include "FBI.h"
#include "../valueset/OpTable.h"
inline int isqrt(int v)
{
    return (int) (sqrt((double) v));
}
//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// unary pointwise isqrt I(int) I(int)
//
// Emacs: -*- C++ -*-

//
//	Copyright 1993, Center for Computer Vision and Visualization,
//	University of Florida.  All rights reserved.
//


//
// $Log: unary-op.templ,v $
// Revision 1.4.1.2  1995/01/13  19:37:42  thoth
// CoreImage has been re-merged with Image.  All special stuff should be
// friends of FBI now.
//
// Revision 1.4.1.1  1994/12/28  17:22:11  thoth
// image operations are friends of FBI now.
//
// Revision 1.4  1994/07/25  17:26:39  thoth
// Name sanitization
//
// Revision 1.3  1994/01/07  15:15:14  thoth
// Image class is now CoreImage and named image types are
// Image<P,T>.
//
// Revision 1.2  1993/12/29  17:33:18  thoth
// New operator scheme that prevents the need for trivial Image conversions.
//
// Revision 1.1  1993/09/15  13:07:16  thoth
// Initial revision
//
// Revision 1.2  93/05/27  11:49:04  thoth
// Copyright Notices
// 
// Revision 1.1  93/03/10  13:50:00  thoth
// Initial revision
// 

#ifndef UOT_int_int_isqrt
#define UOT_int_int_isqrt
IA_UnaryOperationsTable<IA_BaseImage<IA_Point<int>, int>*,
	IA_BaseImage<IA_Point<int>, int> >
	*IA_Image_IP_int_int_isqrt_tbl;

void IA_fill_Image_IP_int_int_isqrt_tbl();
#endif


IA_Image<IA_Point<int>, int>
isqrt ( const IA_Image<IA_Point<int>, int> &arg)
{
    if (!IA_Image_IP_int_int_isqrt_tbl)
	IA_fill_Image_IP_int_int_isqrt_tbl();

    IA_BaseImage<IA_Point<int>, int>*(*f)
	(IA_BaseImage<IA_Point<int>, int> &);
    f = IA_Image_IP_int_int_isqrt_tbl->lookup_operation (arg.type());

    
    IA_BaseImage<IA_Point<int>, int>	&bip =
	*IA_FBI<IA_Point<int>,IA_Point<int>,int,int,int>
	    ::extract_baseptr(arg);

    return IA_FBI<IA_Point<int>,IA_Point<int>, int,int,int>
	 ::make_Image(f(bip));
}

#ifndef vec_uop_int_int_isqrt
#define vec_uop_int_int_isqrt
static IA_BaseImage<IA_Point<int>, int>*
vec_uo_isqrt(IA_BaseImage<IA_Point<int>, int> &lhs_)
{
    const IA_VectorI<IA_Point<int>, int> *lhs =
	(IA_VectorI<IA_Point<int>, int> *) &lhs_;

    const IA_Set<IA_Point<int> > domain = lhs->domain();
    const unsigned sz = domain.card();
    int *const vec = new int[sz];

    {
	int *ds = vec;
	const int *ls = lhs->vec;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = isqrt(*(ls++));
	}
    }
    return new IA_VectorI<IA_Point<int>, int>(domain, vec, sz, 1);
}
#endif // vec_uop_int_int_isqrt

#ifndef scalar_uop_int_int_isqrt
#define scalar_uop_int_int_isqrt
static IA_BaseImage<IA_Point<int>, int>*
scalar_uo_isqrt(IA_BaseImage<IA_Point<int>, int> &lhs_)
{
    const IA_ConstI<IA_Point<int>, int> *lhs =
	(IA_ConstI<IA_Point<int>, int> *) &lhs_;

    const IA_Set<IA_Point<int> > domain = lhs->domain();

    return new IA_ConstI<IA_Point<int>, int>(domain, isqrt(lhs->value));
}
#endif // scalar_uop_int_int_isqrt

// scalar-scalar operation is trivial

#ifndef iter_uop_int_int_isqrt
#define iter_uop_int_int_isqrt
static IA_BaseImage<IA_Point<int>, int>*
iter_uo_isqrt(IA_BaseImage<IA_Point<int>, int> &lhs)
{
    const IA_Set<IA_Point<int> > domain = lhs.domain();
    const unsigned sz = domain.card();
    int *const vec = new int[sz];

    {
	int *ds = vec;
	int ltmp;
	IA_BaseIVIter<IA_Point<int>, int>	*liter = lhs.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    liter->next(ltmp);
	    *(ds++) = isqrt(ltmp);
	}
	delete liter;
    }
    return new IA_VectorI<IA_Point<int>, int>(domain, vec, sz, 1);
}
#endif // iter_uop_int_int_isqrt

#ifndef FILL_UOT_int_int_isqrt
#define FILL_UOT_int_int_isqrt
void IA_fill_Image_IP_int_int_isqrt_tbl()
{
    if (IA_Image_IP_int_int_isqrt_tbl)
	return;

    IA_UnaryOperationsTable<IA_BaseImage<IA_Point<int>, int>*,
	IA_BaseImage<IA_Point<int>, int> >::function f;
    f = iter_uo_isqrt;

    IA_Image_IP_int_int_isqrt_tbl = new IA_UnaryOperationsTable<IA_BaseImage<IA_Point<int>, int>*,
	IA_BaseImage<IA_Point<int>, int> >(iter_uo_isqrt);
    IA_Image_IP_int_int_isqrt_tbl->add_operation
	(IA_VectorI<IA_Point<int>, int>::s_type(),
	 vec_uo_isqrt);
    IA_Image_IP_int_int_isqrt_tbl->add_operation
	(IA_ConstI<IA_Point<int>, int>::s_type(),
	 scalar_uo_isqrt);

}
#endif // UOT_int_int_isqrt

template <class T>
inline T sqr(T v)
{
    return v*v;
}
//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// unary pointwise sqr I(int) I(int)
//
// Emacs: -*- C++ -*-

//
//	Copyright 1993, Center for Computer Vision and Visualization,
//	University of Florida.  All rights reserved.
//


//
// $Log: unary-op.templ,v $
// Revision 1.4.1.2  1995/01/13  19:37:42  thoth
// CoreImage has been re-merged with Image.  All special stuff should be
// friends of FBI now.
//
// Revision 1.4.1.1  1994/12/28  17:22:11  thoth
// image operations are friends of FBI now.
//
// Revision 1.4  1994/07/25  17:26:39  thoth
// Name sanitization
//
// Revision 1.3  1994/01/07  15:15:14  thoth
// Image class is now CoreImage and named image types are
// Image<P,T>.
//
// Revision 1.2  1993/12/29  17:33:18  thoth
// New operator scheme that prevents the need for trivial Image conversions.
//
// Revision 1.1  1993/09/15  13:07:16  thoth
// Initial revision
//
// Revision 1.2  93/05/27  11:49:04  thoth
// Copyright Notices
// 
// Revision 1.1  93/03/10  13:50:00  thoth
// Initial revision
// 

#ifndef UOT_int_int_sqr
#define UOT_int_int_sqr
IA_UnaryOperationsTable<IA_BaseImage<IA_Point<int>, int>*,
	IA_BaseImage<IA_Point<int>, int> >
	*IA_Image_IP_int_int_sqr_tbl;

void IA_fill_Image_IP_int_int_sqr_tbl();
#endif


IA_Image<IA_Point<int>, int>
sqr ( const IA_Image<IA_Point<int>, int> &arg)
{
    if (!IA_Image_IP_int_int_sqr_tbl)
	IA_fill_Image_IP_int_int_sqr_tbl();

    IA_BaseImage<IA_Point<int>, int>*(*f)
	(IA_BaseImage<IA_Point<int>, int> &);
    f = IA_Image_IP_int_int_sqr_tbl->lookup_operation (arg.type());

    
    IA_BaseImage<IA_Point<int>, int>	&bip =
	*IA_FBI<IA_Point<int>,IA_Point<int>,int,int,int>
	    ::extract_baseptr(arg);

    return IA_FBI<IA_Point<int>,IA_Point<int>, int,int,int>
	 ::make_Image(f(bip));
}

#ifndef vec_uop_int_int_sqr
#define vec_uop_int_int_sqr
static IA_BaseImage<IA_Point<int>, int>*
vec_uo_sqr(IA_BaseImage<IA_Point<int>, int> &lhs_)
{
    const IA_VectorI<IA_Point<int>, int> *lhs =
	(IA_VectorI<IA_Point<int>, int> *) &lhs_;

    const IA_Set<IA_Point<int> > domain = lhs->domain();
    const unsigned sz = domain.card();
    int *const vec = new int[sz];

    {
	int *ds = vec;
	const int *ls = lhs->vec;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = sqr(*(ls++));
	}
    }
    return new IA_VectorI<IA_Point<int>, int>(domain, vec, sz, 1);
}
#endif // vec_uop_int_int_sqr

#ifndef scalar_uop_int_int_sqr
#define scalar_uop_int_int_sqr
static IA_BaseImage<IA_Point<int>, int>*
scalar_uo_sqr(IA_BaseImage<IA_Point<int>, int> &lhs_)
{
    const IA_ConstI<IA_Point<int>, int> *lhs =
	(IA_ConstI<IA_Point<int>, int> *) &lhs_;

    const IA_Set<IA_Point<int> > domain = lhs->domain();

    return new IA_ConstI<IA_Point<int>, int>(domain, sqr(lhs->value));
}
#endif // scalar_uop_int_int_sqr

// scalar-scalar operation is trivial

#ifndef iter_uop_int_int_sqr
#define iter_uop_int_int_sqr
static IA_BaseImage<IA_Point<int>, int>*
iter_uo_sqr(IA_BaseImage<IA_Point<int>, int> &lhs)
{
    const IA_Set<IA_Point<int> > domain = lhs.domain();
    const unsigned sz = domain.card();
    int *const vec = new int[sz];

    {
	int *ds = vec;
	int ltmp;
	IA_BaseIVIter<IA_Point<int>, int>	*liter = lhs.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    liter->next(ltmp);
	    *(ds++) = sqr(ltmp);
	}
	delete liter;
    }
    return new IA_VectorI<IA_Point<int>, int>(domain, vec, sz, 1);
}
#endif // iter_uop_int_int_sqr

#ifndef FILL_UOT_int_int_sqr
#define FILL_UOT_int_int_sqr
void IA_fill_Image_IP_int_int_sqr_tbl()
{
    if (IA_Image_IP_int_int_sqr_tbl)
	return;

    IA_UnaryOperationsTable<IA_BaseImage<IA_Point<int>, int>*,
	IA_BaseImage<IA_Point<int>, int> >::function f;
    f = iter_uo_sqr;

    IA_Image_IP_int_int_sqr_tbl = new IA_UnaryOperationsTable<IA_BaseImage<IA_Point<int>, int>*,
	IA_BaseImage<IA_Point<int>, int> >(iter_uo_sqr);
    IA_Image_IP_int_int_sqr_tbl->add_operation
	(IA_VectorI<IA_Point<int>, int>::s_type(),
	 vec_uo_sqr);
    IA_Image_IP_int_int_sqr_tbl->add_operation
	(IA_ConstI<IA_Point<int>, int>::s_type(),
	 scalar_uo_sqr);

}
#endif // UOT_int_int_sqr

template <class T>
inline T abs(T v)
{
    return (v>=0)?(v):(-v);
}
//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// unary pointwise abs I(int) I(int)
//
// Emacs: -*- C++ -*-

//
//	Copyright 1993, Center for Computer Vision and Visualization,
//	University of Florida.  All rights reserved.
//


//
// $Log: unary-op.templ,v $
// Revision 1.4.1.2  1995/01/13  19:37:42  thoth
// CoreImage has been re-merged with Image.  All special stuff should be
// friends of FBI now.
//
// Revision 1.4.1.1  1994/12/28  17:22:11  thoth
// image operations are friends of FBI now.
//
// Revision 1.4  1994/07/25  17:26:39  thoth
// Name sanitization
//
// Revision 1.3  1994/01/07  15:15:14  thoth
// Image class is now CoreImage and named image types are
// Image<P,T>.
//
// Revision 1.2  1993/12/29  17:33:18  thoth
// New operator scheme that prevents the need for trivial Image conversions.
//
// Revision 1.1  1993/09/15  13:07:16  thoth
// Initial revision
//
// Revision 1.2  93/05/27  11:49:04  thoth
// Copyright Notices
// 
// Revision 1.1  93/03/10  13:50:00  thoth
// Initial revision
// 

#ifndef UOT_int_int_abs
#define UOT_int_int_abs
IA_UnaryOperationsTable<IA_BaseImage<IA_Point<int>, int>*,
	IA_BaseImage<IA_Point<int>, int> >
	*IA_Image_IP_int_int_abs_tbl;

void IA_fill_Image_IP_int_int_abs_tbl();
#endif


IA_Image<IA_Point<int>, int>
abs ( const IA_Image<IA_Point<int>, int> &arg)
{
    if (!IA_Image_IP_int_int_abs_tbl)
	IA_fill_Image_IP_int_int_abs_tbl();

    IA_BaseImage<IA_Point<int>, int>*(*f)
	(IA_BaseImage<IA_Point<int>, int> &);
    f = IA_Image_IP_int_int_abs_tbl->lookup_operation (arg.type());

    
    IA_BaseImage<IA_Point<int>, int>	&bip =
	*IA_FBI<IA_Point<int>,IA_Point<int>,int,int,int>
	    ::extract_baseptr(arg);

    return IA_FBI<IA_Point<int>,IA_Point<int>, int,int,int>
	 ::make_Image(f(bip));
}

#ifndef vec_uop_int_int_abs
#define vec_uop_int_int_abs
static IA_BaseImage<IA_Point<int>, int>*
vec_uo_abs(IA_BaseImage<IA_Point<int>, int> &lhs_)
{
    const IA_VectorI<IA_Point<int>, int> *lhs =
	(IA_VectorI<IA_Point<int>, int> *) &lhs_;

    const IA_Set<IA_Point<int> > domain = lhs->domain();
    const unsigned sz = domain.card();
    int *const vec = new int[sz];

    {
	int *ds = vec;
	const int *ls = lhs->vec;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = abs(*(ls++));
	}
    }
    return new IA_VectorI<IA_Point<int>, int>(domain, vec, sz, 1);
}
#endif // vec_uop_int_int_abs

#ifndef scalar_uop_int_int_abs
#define scalar_uop_int_int_abs
static IA_BaseImage<IA_Point<int>, int>*
scalar_uo_abs(IA_BaseImage<IA_Point<int>, int> &lhs_)
{
    const IA_ConstI<IA_Point<int>, int> *lhs =
	(IA_ConstI<IA_Point<int>, int> *) &lhs_;

    const IA_Set<IA_Point<int> > domain = lhs->domain();

    return new IA_ConstI<IA_Point<int>, int>(domain, abs(lhs->value));
}
#endif // scalar_uop_int_int_abs

// scalar-scalar operation is trivial

#ifndef iter_uop_int_int_abs
#define iter_uop_int_int_abs
static IA_BaseImage<IA_Point<int>, int>*
iter_uo_abs(IA_BaseImage<IA_Point<int>, int> &lhs)
{
    const IA_Set<IA_Point<int> > domain = lhs.domain();
    const unsigned sz = domain.card();
    int *const vec = new int[sz];

    {
	int *ds = vec;
	int ltmp;
	IA_BaseIVIter<IA_Point<int>, int>	*liter = lhs.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    liter->next(ltmp);
	    *(ds++) = abs(ltmp);
	}
	delete liter;
    }
    return new IA_VectorI<IA_Point<int>, int>(domain, vec, sz, 1);
}
#endif // iter_uop_int_int_abs

#ifndef FILL_UOT_int_int_abs
#define FILL_UOT_int_int_abs
void IA_fill_Image_IP_int_int_abs_tbl()
{
    if (IA_Image_IP_int_int_abs_tbl)
	return;

    IA_UnaryOperationsTable<IA_BaseImage<IA_Point<int>, int>*,
	IA_BaseImage<IA_Point<int>, int> >::function f;
    f = iter_uo_abs;

    IA_Image_IP_int_int_abs_tbl = new IA_UnaryOperationsTable<IA_BaseImage<IA_Point<int>, int>*,
	IA_BaseImage<IA_Point<int>, int> >(iter_uo_abs);
    IA_Image_IP_int_int_abs_tbl->add_operation
	(IA_VectorI<IA_Point<int>, int>::s_type(),
	 vec_uo_abs);
    IA_Image_IP_int_int_abs_tbl->add_operation
	(IA_ConstI<IA_Point<int>, int>::s_type(),
	 scalar_uo_abs);

}
#endif // UOT_int_int_abs

template <class T>
inline T sgn(T v)
{
    return (v>0)?1:(v<0)?-1:0;
}
//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// unary pointwise sgn I(int) I(int)
//
// Emacs: -*- C++ -*-

//
//	Copyright 1993, Center for Computer Vision and Visualization,
//	University of Florida.  All rights reserved.
//


//
// $Log: unary-op.templ,v $
// Revision 1.4.1.2  1995/01/13  19:37:42  thoth
// CoreImage has been re-merged with Image.  All special stuff should be
// friends of FBI now.
//
// Revision 1.4.1.1  1994/12/28  17:22:11  thoth
// image operations are friends of FBI now.
//
// Revision 1.4  1994/07/25  17:26:39  thoth
// Name sanitization
//
// Revision 1.3  1994/01/07  15:15:14  thoth
// Image class is now CoreImage and named image types are
// Image<P,T>.
//
// Revision 1.2  1993/12/29  17:33:18  thoth
// New operator scheme that prevents the need for trivial Image conversions.
//
// Revision 1.1  1993/09/15  13:07:16  thoth
// Initial revision
//
// Revision 1.2  93/05/27  11:49:04  thoth
// Copyright Notices
// 
// Revision 1.1  93/03/10  13:50:00  thoth
// Initial revision
// 

#ifndef UOT_int_int_sgn
#define UOT_int_int_sgn
IA_UnaryOperationsTable<IA_BaseImage<IA_Point<int>, int>*,
	IA_BaseImage<IA_Point<int>, int> >
	*IA_Image_IP_int_int_sgn_tbl;

void IA_fill_Image_IP_int_int_sgn_tbl();
#endif


IA_Image<IA_Point<int>, int>
sgn ( const IA_Image<IA_Point<int>, int> &arg)
{
    if (!IA_Image_IP_int_int_sgn_tbl)
	IA_fill_Image_IP_int_int_sgn_tbl();

    IA_BaseImage<IA_Point<int>, int>*(*f)
	(IA_BaseImage<IA_Point<int>, int> &);
    f = IA_Image_IP_int_int_sgn_tbl->lookup_operation (arg.type());

    
    IA_BaseImage<IA_Point<int>, int>	&bip =
	*IA_FBI<IA_Point<int>,IA_Point<int>,int,int,int>
	    ::extract_baseptr(arg);

    return IA_FBI<IA_Point<int>,IA_Point<int>, int,int,int>
	 ::make_Image(f(bip));
}

#ifndef vec_uop_int_int_sgn
#define vec_uop_int_int_sgn
static IA_BaseImage<IA_Point<int>, int>*
vec_uo_sgn(IA_BaseImage<IA_Point<int>, int> &lhs_)
{
    const IA_VectorI<IA_Point<int>, int> *lhs =
	(IA_VectorI<IA_Point<int>, int> *) &lhs_;

    const IA_Set<IA_Point<int> > domain = lhs->domain();
    const unsigned sz = domain.card();
    int *const vec = new int[sz];

    {
	int *ds = vec;
	const int *ls = lhs->vec;
	for (unsigned i=0; i<sz; i++) {
	    *(ds++) = sgn(*(ls++));
	}
    }
    return new IA_VectorI<IA_Point<int>, int>(domain, vec, sz, 1);
}
#endif // vec_uop_int_int_sgn

#ifndef scalar_uop_int_int_sgn
#define scalar_uop_int_int_sgn
static IA_BaseImage<IA_Point<int>, int>*
scalar_uo_sgn(IA_BaseImage<IA_Point<int>, int> &lhs_)
{
    const IA_ConstI<IA_Point<int>, int> *lhs =
	(IA_ConstI<IA_Point<int>, int> *) &lhs_;

    const IA_Set<IA_Point<int> > domain = lhs->domain();

    return new IA_ConstI<IA_Point<int>, int>(domain, sgn(lhs->value));
}
#endif // scalar_uop_int_int_sgn

// scalar-scalar operation is trivial

#ifndef iter_uop_int_int_sgn
#define iter_uop_int_int_sgn
static IA_BaseImage<IA_Point<int>, int>*
iter_uo_sgn(IA_BaseImage<IA_Point<int>, int> &lhs)
{
    const IA_Set<IA_Point<int> > domain = lhs.domain();
    const unsigned sz = domain.card();
    int *const vec = new int[sz];

    {
	int *ds = vec;
	int ltmp;
	IA_BaseIVIter<IA_Point<int>, int>	*liter = lhs.value_iterator();
	for (unsigned i=0; i<sz; i++) {
	    liter->next(ltmp);
	    *(ds++) = sgn(ltmp);
	}
	delete liter;
    }
    return new IA_VectorI<IA_Point<int>, int>(domain, vec, sz, 1);
}
#endif // iter_uop_int_int_sgn

#ifndef FILL_UOT_int_int_sgn
#define FILL_UOT_int_int_sgn
void IA_fill_Image_IP_int_int_sgn_tbl()
{
    if (IA_Image_IP_int_int_sgn_tbl)
	return;

    IA_UnaryOperationsTable<IA_BaseImage<IA_Point<int>, int>*,
	IA_BaseImage<IA_Point<int>, int> >::function f;
    f = iter_uo_sgn;

    IA_Image_IP_int_int_sgn_tbl = new IA_UnaryOperationsTable<IA_BaseImage<IA_Point<int>, int>*,
	IA_BaseImage<IA_Point<int>, int> >(iter_uo_sgn);
    IA_Image_IP_int_int_sgn_tbl->add_operation
	(IA_VectorI<IA_Point<int>, int>::s_type(),
	 vec_uo_sgn);
    IA_Image_IP_int_int_sgn_tbl->add_operation
	(IA_ConstI<IA_Point<int>, int>::s_type(),
	 scalar_uo_sgn);

}
#endif // UOT_int_int_sgn

//////////////////////////////////////////////////////////////////////
//
// Begin operation support routines for :
// filename IIO-minmax.c
//
