// chain-code.h         Section: 12.2
//      Copyright 1994, Center for Computer Vision and Visualization,
//      University of Florida.  All rights reserved.

// Chain Code extraction.


#ifndef _chain_code_h_
#define _chain_code_h_

#include "Array.h"
#include "BitDI.h"


IA_Array<u_char>
chain_code( const IA_Image<IA_Point<int>,IA_Bit> & source,
	    IA_Point<int> & x0 );



IA_Image<IA_Point<int>,IA_Bit>
chain_code_image( const IA_Array<u_char> & chain_code,
		  const IA_Set<IA_Point<int> > & cc_domain,
		  const IA_Point<int> & start );


double
chain_code_correlation( const IA_Array<u_char> & chain_1,
			const IA_Array<u_char> & chain_2 );

#endif
