// median.h             Section: 2.8
//      Copyright 1994, Center for Computer Vision and Visualization,
//      University of Florida.  All rights reserved.
// Image Algebra C++ implementation of a  median filter
//

#ifndef _median_h_
#define _median_h_

#include "UcharDI.h"
#include "IntDI.h"
#include "FloatDI.h"
#include "Nbh.h"


///////////////////////////////////////////////////////////////////
// median()
// Calculate the median image for this image, based on a
//   user supplied neighborhood.

template <class P, class T>
IA_Image<P,T>
median( const IA_Image<P,T> & image,
	const IA_Neighborhood<P,P> & median_nbhd  );

#endif
